# MolBar

<div align="center">
<img src="logo.png" alt="logo" width="400" />
</div>

This package provides an implementation of the Molecular Barcode (MolBar) as a quantum chemistry-inspired molecular identifier to ensure data uniqueness in databases, supporting organic and inorganic molecules while attempting to describe relative and absolute configuration including centric, axial/helical and planar chirality.

[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)
[![PyPI Downloads](https://img.shields.io/pypi/dm/molbar.svg?label=PyPI%20downloads)](https://pypi.org/project/molbar/)
[![ChemRxiv Paper](https://img.shields.io/badge/DOI-10.1038%2Fs41586--020--2649--2-blue)](
https://chemrxiv.org/engage/chemrxiv/article-details/65e3cd80e9ebbb4db9c71da0)

- **ChemRxiv Paper:** https://chemrxiv.org/engage/chemrxiv/article-details/65e3cd80e9ebbb4db9c71da0
- **Documentation:** https://git.rwth-aachen.de/bannwarthlab/molbar/-/blob/main/README.md?ref_type=heads
- **Source code:** https://git.rwth-aachen.de/bannwarthlab/molbar
- **Bug reports:** https://git.rwth-aachen.de/bannwarthlab/molbar/-/issues
- **Email contact:** van.staalduinen@pc.rwth-aachen.de

It does this by fragmentating a molecule into rigid parts which are then idealized with a specialized non-physical force field. The molecule is then described by different matrices encoding topology (connectivity), topography (3D positions of atoms after input unification), and absolute configuration (by calculating a chirality index). The final barcode is the concatenated spectra of these matrices. It should work well for organic and inorganic molecules with typical 2c2e bonding. Here it can describe organic and inorganic molecules based on their relative and absolute configuration, including centric, axial/helical, and planar chirality.

## Current Limitations 

**The input file (.xyz/.sdf/.mol/.com/.gjf/.cif) must contain 3D coordinates and explicit hydrogens.**
Near-term feature development will address 2D coordinates as a starting point, computational cost, and metal complexes with η bonds.

As the usual starting point are 3D Cartesian coordinates, right now, problems can occur if it is not easy to determine which atoms are bonded, especially for metal complexes with η-bonds. Further, problems can occur if the geometry around a metal in a complex cannot be classified by one of the standard VSEPR model. If you are not sure, just use the -d option when using MolBar as a commandline tool or use  write_trj=True when using MolBar as a Python module to look at the optimized trajectories of each fragment. If something is unclear to you or something unusual happens, I would appreciate if you report it by posting issues or by e-mail (van.staalduinen@pc.rwth-aachen.de).

For rigidity analysis, MolBar only considers double/triple bonds and rings to be rigid. For example, an obstacle to rotation due to bulkiness of substituents is not taken into account, but can be added manually from the input file (additional dihedral constraint, but that should be used as an exception and carefully).


## Getting started (tested on Linux and macOS, compiling works for Windows only in WSL)

### For Linux/macOS

Using a virtual environment is highly recommended because it allows you to create isolated environments with their own dependencies, without interfering with other Python projects or the system Python installation. This ensures that your Python environment remains consistent and reproducible across different machines and over time. To create one, type in the following command in your terminal:

```bash
 python3 -m venv path/to/venv
```
To activate the enviroment, type in:
```bash
 source path/to/venv/bin/activate
```
To install Molbar, enter`the following command in your terminal:

```bash
pip install molbar
```

### For Windows

Since compiling in a standard Windows environment does not work yet, it is highly recommended to use the WSL (Windows Subsystem for Linux) extension. Simply follow this installation guide: https://learn.microsoft.com/en-us/windows/wsl/install. Note that a Fortran compiler needs to be installed manually in the WSL environment. Otherwise, the installation of MolBar will result in an error.

For Python usage, it is highly recommended to use Visual Studio Code (VSC) as it provides specific extensions to code directly in WSL. A more detailed guide can be found here: https://code.visualstudio.com/docs/remote/wsl


# MolBar Structure

For l-alanine, the MolBar reads:

```text

MolBar | 1.0.0 | C3NO2H7 | -339 -140 -110 -32 13 20 20 20 160 237 432 528 850 | -209 -8 130 160 354 633 | -154 -117 -67 -40 9 9 9 60 74 156 342 457 922 | -31 0 0 0 11

```

MolBar is constructed as follows: 

```text
Version: 1.0.0
Molecular Formula: C3H7NO2 
Topology Spectrum: -339 -140 -110 -32 13 20 20 20 160 237 432 528 850 (Encoding atomic connectivity)
Heavy Atom Topology Spectrum: -209 -8 130 160 354 633 (Encoding atomic connectivity without hydrogen atoms. So if for two molecules, the topology spectra are different but the tautomer spectra are the same, both molecules are tautomeric structures)
Topography Spectrum : -154 -117 -67 -40 9 9 9 60 74 156 342 457 922 (3D arrangement of atoms in Cartesian space, also describes diastereomerism)
Absolute Configuration: -31 0 0 0 11 (Encoding absolute configuration for each fragment)
```

## Python Module Usage

MolBar can be generated by Python function calls:

1. for a single molecule with ```get_molbars_from_coordinates``` by specifying the Cartesian coordinates as a list,
2. for several molecules at once with ```get_molbars_from_coordinates``` by giving a list of lists with Cartesian coordinates,
3. for a single molecule with ```get_molbars_from_file``` by specifying a file path,
4. for several molecules at once with ```get_molbars_from_files``` by specifying a list of file paths.

### 1. get_molbar_from_coordinates

```python
  from molbar.barcode import get_molbar_from_coordinates

  def get_molbar_from_coordinates(coordinates: list, elements: list, return_data=False, timing=False, input_constraint=None, mode="mb") -> Union[str, dict]

      Args:

          coordinates (list): Molecular geometry provided by atomic Cartesian coordinates with shape (n_atoms, 3).
          elements (list): A list of elements in that molecule.
          return_data (bool): Whether to return MolBar data.
          timing (bool): Whether to print the duration of this calculation.
          input_constraint (dict, optional): A dict of extra constraints for the calculation. See below for more information. USED ONLY IN EXCEPTIONAL CASES.
          mode (str): Whether to calculate the molecular barcode ("mb") or only the topology part of the molecular barcode ("topo").

      Returns:

          Union[str, dict]: Either MolBar or the MolBar and MolBar data.

  ```

Example for input constraints as a Python dict. Input constraint should be used only in exceptional cases. However, it may be useful to constrain bonds with a additional dihedral for the barcode that are normally considered single bonds but whose rotation is hindered (e.g., 90° binol systems with bulky substituents).

  ```python
  {
  'constraints': {
                  'dihedrals': [{'atoms': [1,2,3,4], 'value':90.0},...]} #atoms: list of atoms that define the dihedral, value is the ideal dihedral angle in degrees, atom indexing starts with 1.
  }
  ```


### 2. get_molbars_from_coordinates
NOTE:
If you need to process multiple molecules at once, it is recommended to use this function and specify the number of threads that can be used to process multiple molecules simultaneously.

  ```python
  from molbar.barcode import get_molbars_from_coordinates

  def get_molbars_from_coordinates(list_of_coordinates: list, list_of_elements: list, return_data=False, threads=1, timing=False, input_constraints=None, progress=False,  mode="mb") -> Union[list, Union[str, dict]]:

      Args:

          list_of_coordinates (list): A list of molecular geometries provided by atomic Cartesian coordinates with shape (n_molecules, n_atoms, 3).
          list_of_elements (list): A list of element lists for each molecule in the list_of_coordinates with shape (n_molecules, n_atoms).
          return_data (bool): Whether to return MolBar data.
          threads (int): Number of threads to use for the calculation. If you need to process multiple molecules at once, it is recommended to use this function and specify the number of threads that can be used to process multiple molecules simultaneously.
          timing (bool):  Whether to print the duration of this calculation.
          input_constraints (list, optional): A list of constraints for the calculation. Each constraint in that list is a Python dict as shown above for get_molbar_from_coordinates.
          progress (bool): Whether to show a progress bar.
          mode (str): Whether to calculate the molecular barcode ("mb") or the topology part of the molecular barcode ("topo").

      Returns:

          Union[list, Union[str, dict]]: Either MolBar or the MolBar and MolBar data.
```

### 3. get_molbar_from_file

  ```python
  from molbar.barcode import get_molbar_from_file

  def get_molbar_from_file(file: str, return_data=False, timing=False, input_constraint=None, mode="mb", write_trj=False) -> Union[str, dict]:

      Args:
          file (str): The path to the file containing the molecule information (either .xyz/.sdf/.mol/.com/.gjf/.cif format).
          return_data (bool): Whether to return MolBar data.
          timing (bool): Whether to print the duration of this calculation.
          input_constraint (dict, optional): A dict of extra constraints for the calculation. See below for more information. USED ONLY IN EXCEPTIONAL CASES.
          mode (str): Whether to calculate the molecular barcode ("mb") or only the topology part of the molecular barcode ("topo").
          write_trj (bool, optional): Whether to write a trajectory of the unification process. Defaults to False.
      
      Returns:

          Union[str, dict]: Either MolBar or the MolBar and MolBar data.

  ```

Example for input file in .yml format. Input constraint should be used only in exceptional cases. However, it may be useful to constrain bonds with a additional dihedral for the barcode that are normally considered single bonds but whose rotation is hindered (e.g., 90° binol systems with bulky substituents).
```yml
constraints:
  dihedrals:
    - atoms: [30, 18, 14, 13]  # List of atoms involved in the dihedral
      value:  90.0  # Actual values for the dihedral parameters
```


### 4. get_molbars_from_files

NOTE:
If you need to process multiple molecules at once, it is recommended to use this function and specify the number of threads that can be used to process multiple molecules simultaneously.

  ```python
  from molbar.barcode import get_molbars_from_files

  def get_molbars_from_files(files: list, return_data=False, threads=1, timing=False, input_constraints=None, progress=False, mode="mb", write_trj=False) ->Union[list, Union[str, dict]]:

      Args:

          files (list): The list of paths to the files containing the molecule information (either .xyz/.sdf/.mol/.com/.gjf/.cif format).
          return_data (bool): Whether to return MolBar data.
          threads (int): Number of threads to use for the calculation. If you need to process multiple molecules at once, it is recommended to use this function and specify the number of threads that can be used to process multiple molecules simultaneously.
          timing (bool):  Whether to print the duration of this calculation.
          input_constraints (list, optional): A list of file paths to the input files for the calculation. Each constrained is specified by a file path to a .yml file, as shown above for get_molbar_from_file.
          progress (bool): Whether to show a progress bar.
          mode (str): Whether to calculate the molecular barcode ("mb") or the topology part of the molecular barcode ("topo").
          write_trj (bool, optional): Whether to write a trajectory of the unification process. Defaults to False.

      Returns:

          Union[list, Union[str, dict]]: Either MolBar or the MolBar and MolBar data.

  ```


## Commandline Usage

MolBar can also be used as commandline tool. Just simply type:

```
molbar coord.xyz
```
and the MolBar is printed to the stdout.

NOTE:
If you need to process several molecules at once, it is recommended to pass all molecules to the code at once (e.g. with *.xyz) while specifying the number of threads the code should use:
```bash
molbar *.xyz -T N_threads -s
```
The latter option (-s) is used to store the barcode to .mb files. 


Further, the commandline tool provides several options:

```text
usage: molbar [-h] [-r] [-i INP [INP ...]] [-d] [-T THREADS] [-s] [-t] [-p] [-m {mb,topo,opt}] files [files ...]

positional arguments:
  files                 file(s)

options:
  -m {mb,topo,opt}, --mode {mb,topo,opt}
                      The mode to use for the calculations (either "mb" (default, calculates MolBar), "topo" (topology part only)
                      or "opt" (using stand-alone force field idealization, writes ".opt" with final structure))

  -i INP [INP ...], --inp INP [INP ...]
                        Path to input file in .yml format to add further constraints. Example input can be found below.

  -d, --data           Whether to print MolBar data. 
                        Writes a "filename/" directory containing a json file with
                        important information that defines MolBar. Writes idealization trajectories of each fragment to same directory.

  -T THREADS, --threads THREADS
                        The number of threads to use for parallel processing of several files. MolBar generation for a single file is not parallelized. Should be used together with -s/--save (e.g. molbar *.xyz -T 8 -s)

  -s, --save            Whether to save the result to a file of type "filename.mb"
  -t, --time            Print out timings.

  -p, --progress        Use a progress bar when several files are handled.
```

Example for input file constraints in yml format. Input constraint should be used only in exceptional cases. However, it may be useful to constrain bonds with a additional dihedral for the barcode that are normally considered single bonds but whose rotation is hindered (e.g., 90° binol systems with bulky substituents).

```yml
constraints:
  dihedrals:
    - atoms: [30, 18, 14, 13]  # List of atoms involved in the dihedral
      value:  90.0  # Actual values for the dihedral parameters
```



## Using the unification force field for the whole molecule.

The force field can be used to idealize the structure of a whole molecule where the coordinates are either given in Python by a file:

1. as a commandline tool with the ```molbar coord.xyz -m opt``` option
2. in Python with ```idealize_structure_from_file``` by providing a file path
3. in Python with ```idealize_structure_from_coordinates``` by providing Cartesian coordinates as a list
 

### Commandline tool
```text
molbar coord.xyz -m opt
```
This writes a coord.opt file that contains the idealized coordinates.

### In Python from a file:
```python
  from molbar.barcode import idealize_structure_from_file

  def idealize_structure_from_file(file: str, return_data=False, timing=False, input_constraint=None,  write_trj=False) -> Union[list, str]

      Args:

          file (str): The path to the input file to be processed.
          return_data (bool): Whether to print MolBar data.
          timing (bool): Whether to print the duration of this calculation.
          input_constraint (str): The path to the input file containing the constraint for the calculation. See down below for more information.
          write_trj (bool, optional): Whether to write a trajectory of the unification process. Defaults to False.
      Returns:
          n_atoms (int): Number of atoms in the molecule.
          energy (float): Final energy of the molecule after idealization.
          coordinates (list): Final coordinates of the molecule after idealization.
          elements (list): Elements of the molecule.
          data (dict): Molbar data.
```

This is an example input as a yml file:
```yml
bond_order_assignment: False  # False if bond order assignment should be skipped, only reasonable opt mode (standalone force-field optimization)
cycle_detection: True # False if cycle detection should be skipped, only reasonable opt mode (standalone force-field optimization).
repulsion_charge: 100.0 # Charged used for the Coulomb term in the Force field, every atom-atom pair uses the same charge, only reasonable opt mode (standalone force-field optimization). Defaults to 100.0
set_edges: True #False if no bonds should be constrained automatically.
set_angles: True #False if no angles should be constrained automatically.
set_dihedrals: True # False if no dihedrals should be constrained automatically.
set_repulsion: True #False if no coulomb term should be used automatically.

constraints:
  bonds:
    - atoms: [19, 23]  # List of atoms involved in the bond
      value: 1.5  # Ideal bond length. 
  angles:
    - atoms: [19, 23, 35]  # List of atoms involved in the angle
      value: 45.0  # Angle to which the angle between the three atoms is to be constrained
    - atoms: [35, 23, 19]  # List of atoms involved in the angle
      value: 45.0  # Angle to which the angle between the three atoms is to be constrained

  dihedrals:
    - atoms: [30, 18, 14, 13]  # List of atoms involved in the dihedral
      value:  90.0  # Actual values for the dihedral parameters
```

### In Python from a list of Cartesian coordinates:
```python
from molbar.barcode import idealize_structure_from_coordinates

def idealize_structure_from_coordinates(coordinates: list, elements: list, return_data=False, timing=False, input_constraint=None) -> Union[list, str]:

      Args:
          coordinates (list): Cartesian coordinates of the molecule.
          elements (list): Elements of the molecule.
          return_data (bool, optional): Whether to return MolBar data.
          timing (bool, optional): Whether to print the duration of this calculation.
          input_constraint (dict, optional): The constraint for the calculation. See documentation for more information.
          
      Returns:
          n_atoms (int): Number of atoms in the molecule.
          energy (float): Final energy of the molecule after idealization.
          coordinates (list): Final coordinates of the molecule after idealization.
          elements (list): Elements of the molecule.
          data (dict): MolBar data.
```

This is an example input as a Python dict:

```python
  {'bond_order_assignment': True, #False if bond order assignment should be skipped, only reasonable opt mode (standalone force-field optimization)
  'cycle_detection': True, #False if cycle detection should be skipped, only reasonable opt mode (standalone force-field optimization).
  'set_edges': True #False if no bonds should be constrained automatically.
  'set_angles': True #False if no angles should be constrained automatically.
  'set_dihedrals': True #False if no dihedrals should be constrained automatically.
  'set_repulsion': True #False if no coulomb term should be used automatically.
  'repulsion_charge': 100.0, # Charged used for the Coulomb term in the Force field, every atom-atom pair uses the same charge, only reasonable opt mode (standalone force-field optimization). Defaults to 100.0
  'constraints': {'bonds': [{'atoms': [1,2], 'value':1.5},...], #atoms: list of atoms that define the bond, value is the ideal bond length in angstrom, atom indexing starts with 1.
                  'angles': [{'atoms': [1,2,3], 'value':90.0},...], #atoms: list of atoms that define the angle, value is the ideal angle in degrees, atom indexing starts with 1.
                  'dihedrals': [{'atoms': [1,2,3,4], 'value':180.0},...]}  #atoms: list of atoms that define the dihedral, value is the ideal dihedral angle in degrees, atom indexing starts with 1.
  }
```

## Acknowledgements

MolBar relies on the following libraries
and packages:

*   [networkx](https://networkx.org/)
*   [NumPy](https://numpy.org)
*   [SciPy](https://scipy.org)
*   [tqdm](https://github.com/tqdm/tqdm)
*   [joblib](https://joblib.readthedocs.io/en/latest/)

Thank you!

## License and Disclaimer

MIT License

Copyright (c) 2022 Nils van Staalduinen, Christoph Bannwarth

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

module bond_order_detection

use unsaturated_edges, only: get_unsaturated_atoms, get_unsaturated_bond_matrix, get_unsaturated_bonds
use valence_conditions, only: get_total_charge, check_valence
use unsaturated_graph, only: get_combinations, get_matching
implicit none
public :: get_best_bo_matrix
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_best_bo_matrix(n_atoms, cn_matrix, cn, atoms, all_possible_valences, are_core, best_bo_matrix)
    integer, intent(in) :: n_atoms
    integer, intent(in) :: cn_matrix(:,:)
    integer, intent(in) :: cn(:)
    integer, intent(in) :: all_possible_valences(:,:)
    integer, intent(in) :: are_core(:)
    integer, intent(in) :: atoms(:)
    integer, intent(out) :: best_bo_matrix(n_atoms,n_atoms)
    integer :: bo_matrix(n_atoms,n_atoms)
    integer :: bo_charge, energy
    integer :: best_bo_charge, best_energy
    integer :: i, j, k, x, y

    best_bo_charge = 0
    best_energy = 0

    do i=1, size(all_possible_valences, dim=2)
        !write(*,*) all_possible_valences(:,i)
        call get_bo_matrix_for_valence(n_atoms,  atoms, cn_matrix, cn, & 
                                        all_possible_valences(:,i), are_core, bo_matrix, bo_charge, energy)

        !write(*,*) "new_best", energy, best_energy, bo_charge, best_bo_charge
        if (i == 1) then
            best_bo_matrix = bo_matrix
            best_bo_charge = bo_charge
            best_energy = energy
        else
            if (energy > best_energy .and. bo_charge <= best_bo_charge) then
                best_bo_charge = bo_charge
                best_energy = energy
                best_bo_matrix = bo_matrix
            else if (energy <= best_energy .and. bo_charge < best_bo_charge) then
                best_bo_charge = bo_charge
                best_energy = energy
                best_bo_matrix = bo_matrix
            else if (energy == best_energy .and. bo_charge == best_bo_charge) then
                do j=1, n_atoms
                    do k=1, n_atoms
                        if (k > j .and. bo_matrix(j,k) > best_bo_matrix(j,k)) then
                            best_bo_matrix(j,k) = bo_matrix(j,k)
                            best_bo_matrix(k,j) = bo_matrix(k,j)
                        endif
                    enddo
                enddo
            endif
        endif
    enddo

end subroutine get_best_bo_matrix

subroutine get_bo_matrix_for_valence(n_atoms, atoms, cn_matrix, cn, valences,&
                                         are_core, best_bo_matrix, best_bo_charge, best_energy)
    integer, intent(in) :: n_atoms
    integer, intent(in) :: cn_matrix(:,:)
    integer, intent(in) :: cn(:)
    integer, intent(in) :: valences(:)
    integer, intent(in) :: atoms(:)
    integer, intent(in) :: are_core(:)
    integer, intent(out) :: best_bo_matrix(:,:)
    integer, intent(out) :: best_bo_charge
    integer, intent(out) :: best_energy
    integer :: bo_matrix(n_atoms,n_atoms)
    integer :: unsaturated_atoms(n_atoms), degree_unsaturation(n_atoms), unsaturated_bond_matrix(n_atoms,n_atoms)
    integer :: i, j, k, l, m, x,y,n_bonds
    integer, allocatable :: unsaturated_bonds(:,:)
    integer, allocatable :: combinations(:,:,:)
    integer, allocatable :: pairs(:,:)
    integer :: energy, sum_abs_charge, abs_sum_charge, bo_charge, summe
    logical :: healthy

    best_bo_matrix = cn_matrix

    call get_total_charge(n_atoms, atoms, valences, are_core, cn_matrix, energy, sum_abs_charge, abs_sum_charge)

    best_energy = energy

    best_bo_charge = sum_abs_charge

    call get_unsaturated_atoms(n_atoms, valences, cn, unsaturated_atoms, degree_unsaturation)

    call get_unsaturated_bond_matrix(n_atoms, cn_matrix, unsaturated_atoms, unsaturated_bond_matrix, n_bonds)

    if (n_bonds == 0) then
        return
    endif
    
    allocate(unsaturated_bonds(2,n_bonds))

    call get_unsaturated_bonds(unsaturated_bond_matrix, unsaturated_bonds)
    
    k = count(unsaturated_atoms == 1)/2

    if (k == 0) then
        return
    endif 

    allocate(combinations(2, k, n_bonds))

    call get_combinations(n_atoms, unsaturated_bonds, n_bonds, k, combinations)

    allocate(pairs(2,k))

    !write(*,*) "new_valence"
    do i=1, n_bonds

        pairs = combinations(:,:,i)

        !write(*,*) pairs
        
        call get_bo_matrix(n_atoms, cn_matrix, unsaturated_atoms, degree_unsaturation, valences, & 
                            pairs, bo_matrix)
        
        call get_total_charge(n_atoms, atoms, valences, are_core, bo_matrix, energy, sum_abs_charge, abs_sum_charge)

        call check_valence(n_atoms, bo_matrix, valences, healthy)

        !write(*,*) energy, sum_abs_charge, healthy

        if (energy > best_energy .and. sum_abs_charge < best_bo_charge .and. healthy) then

            best_bo_charge = sum_abs_charge
            best_energy = energy
            best_bo_matrix = bo_matrix
            !write(*,*) "best", best_energy, best_bo_charge

        else if (energy == best_energy .and. sum_abs_charge < best_bo_charge .and. healthy) then

            best_bo_charge = sum_abs_charge
            best_energy = energy
            best_bo_matrix = bo_matrix
            !write(*,*) "best", best_energy, best_bo_charge

        else if (energy > best_energy .and. sum_abs_charge == best_bo_charge .and. healthy) then

            best_bo_charge = sum_abs_charge
            best_energy = energy
            best_bo_matrix = bo_matrix
            !write(*,*) "best", best_energy, best_bo_charge

        else if (energy == best_energy .and. sum_abs_charge == best_bo_charge .and. healthy) then

            do j=1, n_atoms
                do k=1, n_atoms
                    if (k > j .and. bo_matrix(j,k) > best_bo_matrix(j,k)) then
                        best_bo_matrix(j,k) = bo_matrix(j,k)
                        best_bo_matrix(k,j) = bo_matrix(k,j)
                    endif
                enddo
            enddo
        endif
    enddo

end subroutine get_bo_matrix_for_valence

subroutine get_bo_matrix(n_atoms, cn_matrix, given_unsaturated_atoms, given_degree_unsaturation, valences, & 
                            starting_pairs, bo_matrix)
    integer, intent(in) :: n_atoms
    integer, intent(in) :: cn_matrix(:,:)
    integer, intent(in) :: given_unsaturated_atoms(:)
    integer, intent(in) :: given_degree_unsaturation(:)
    integer, intent(in) :: valences(:)
    integer, intent(in) :: starting_pairs(:,:)
    integer, intent(out) :: bo_matrix(:,:)
    integer :: i, j, k, l, n_bonds, n_combi
    integer, allocatable :: combinations(:,:,:)
    integer, allocatable :: unsaturated_bonds(:,:)
    integer :: old_degree_unsaturation(n_atoms)
    integer :: current_valences(n_atoms)
    integer :: unsaturated_bond_matrix(n_atoms,n_atoms)
    integer :: current_valence
    integer :: flag
    integer, allocatable :: pairs(:,:), unsaturated_atoms(:), degree_unsaturation(:)

    bo_matrix = cn_matrix

    old_degree_unsaturation = 0

    flag = 0

    allocate(pairs(2,size(starting_pairs, dim=2)))

    pairs = starting_pairs

    allocate(unsaturated_atoms(n_atoms))
    
    unsaturated_atoms = given_unsaturated_atoms

    allocate(degree_unsaturation(n_atoms))

    degree_unsaturation = given_degree_unsaturation

    do while (flag==0)

        flag = 1  

        do j = 1, n_atoms
            if (old_degree_unsaturation(j) /= degree_unsaturation(j)) then
                flag = 0
                exit
            endif
        enddo

        if (flag == 1) then
            exit
        endif

        do i = 1, size(pairs, dim=2)
            if (pairs(1,i) /= 0 .and. pairs(2,i) /= 0) then
                bo_matrix(pairs(1,i), pairs(2,i)) = bo_matrix(pairs(1,i), pairs(2,i)) + 1
                bo_matrix(pairs(2,i), pairs(1,i)) = bo_matrix(pairs(2,i), pairs(1,i)) + 1
            endif 
        enddo

        deallocate(pairs)

        current_valences = 0

        do i=1, size(bo_matrix,dim=2)
            current_valences(i) = sum(bo_matrix(:,i))
        enddo
           
        old_degree_unsaturation = degree_unsaturation

        call get_unsaturated_atoms(n_atoms, valences, current_valences, unsaturated_atoms, degree_unsaturation)
        call get_unsaturated_bond_matrix(n_atoms, cn_matrix, unsaturated_atoms, unsaturated_bond_matrix, n_bonds)

        if (n_bonds == 0) then
            return
        endif

        allocate(unsaturated_bonds(2,n_bonds))
        call get_unsaturated_bonds(unsaturated_bond_matrix, unsaturated_bonds)

        k = count(unsaturated_atoms == 1)/2

        if (k == 0) then
            return
        endif

        allocate(pairs(2,k))

        call get_matching(n_atoms, 1, unsaturated_bonds, k, pairs)

        deallocate(unsaturated_bonds)
    enddo

end subroutine get_bo_matrix

end module bond_order_detection

module a_dihedral_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_a_dihedral_derivatives
integer, parameter :: wp = selected_real_kind(15)

contains

subroutine get_a_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,dadx,d2adxdy)
    real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
    real(8), intent(out) :: dadx(12), d2adxdy(78)
    real(8) :: ddx, ddy, ddz
    integer :: i

    call get_agradient(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,dadx)

    call get_ahessian(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,d2adxdy)
    
end subroutine get_a_dihedral_derivatives


subroutine get_ahessian(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,d2adxdy)
    real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
    real(8), intent(out) :: d2adxdy(78)
    real(8) :: derivative
    integer :: ij

    d2adxdy = 0.0_wp
    ! i i = 0
    !j j
    call get_d2adxjdxj(yji, zji, ykj, zkj, ylk, zlk, derivative)
    call gidx(4, 4, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdxj(xji, zji, xkj, zkj, xlk, zlk, derivative)
    call gidx(5, 5, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdxj(xji, yji, xkj, ykj, xlk, ylk, derivative)
    call gidx(6, 6, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyj(xji, yji, xkj, ykj, xlk, ylk, derivative)
    call gidx(4, 5, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyj(xji, zji, xkj, zkj, xlk, zlk, derivative)
    call gidx(4, 6, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyj(yji, zji, ykj, zkj, ylk, zlk, derivative)
    call gidx(5, 6, ij)
    d2adxdy(ij) = derivative

    !i j
    call get_d2adxidxj(ykj, zkj, ylk, zlk, derivative)
    call gidx(1, 4, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxj(xkj, zkj, xlk, zlk, derivative)
    call gidx(2, 5, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxj(xkj, ykj, xlk, ylk, derivative)
    call gidx(3, 6, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(xkj, ykj, xlk, ylk, derivative)
    call gidx(1, 5, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(xkj, zkj, xlk, zlk, derivative)
    call gidx(1, 6, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(ykj, zkj, ylk, zlk, derivative)
    call gidx(2, 6, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(xlk, ylk, xkj, ykj, derivative)
    call gidx(2, 4, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(xlk, zlk, xkj, zkj, derivative)
    call gidx(3, 4, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(ylk, zlk, ykj, zkj, derivative)
    call gidx(3, 5, ij)
    d2adxdy(ij) = derivative

    ! i k 

    call get_d2adxidxk(ykj, zkj, ylk, zlk, derivative)
    call gidx(1, 7, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxk(zkj, xkj, zlk, xlk, derivative)
    call gidx(2, 8, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxk(xkj, ykj, xlk, ylk, derivative)
    call gidx(3, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(xkj, ykj, xlk, ylk,derivative)
    call gidx(1, 8, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(xkj, zkj, xlk, zlk, derivative)
    call gidx(1, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(ykj, zkj, ylk, zlk, derivative)
    call gidx(2, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(ykj, xkj, ylk, xlk, derivative)
    call gidx(2, 7, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(zkj, xkj, zlk, xlk, derivative)
    call gidx(3, 7, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(zkj, ykj, zlk, ylk, derivative)
    call gidx(3, 8, ij)
    d2adxdy(ij) = derivative

    ! j k
    call get_d2adxjdxk(yji,zji,ykj,zkj,ylk,zlk,derivative)
    call gidx(4, 7, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdxk(zji,xji,zkj,xkj,zlk,xlk,derivative)
    call gidx(5, 8, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdxk(xji,yji,xkj,ykj,xlk,ylk,derivative)
    call gidx(6, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyk(xji,yji,xkj,ykj,xlk,ylk,derivative)
    call gidx(4, 8, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyk(xji,zji,xkj,zkj,xlk,zlk,derivative)
    call gidx(4, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyk(yji,zji,ykj,zkj,ylk,zlk,derivative)
    call gidx(5, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyk(yji,xji,ykj,xkj,ylk,xlk,derivative)
    call gidx(5, 7, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyk(zji,xji,zkj,xkj,zlk,xlk,derivative)
    call gidx(6, 7, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyk(zji,yji,zkj,ykj,zlk,ylk,derivative)
    call gidx(6, 8, ij)
    d2adxdy(ij) = derivative

    ! k k 

    call get_d2adxjdxj(ylk, zlk, ykj, zkj, yji, zji, derivative)
    call gidx(7, 7, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdxj(xlk, zlk, xkj, zkj, xji, zji, derivative)
    call gidx(8, 8, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdxj(xlk, ylk, xkj, ykj, xji, yji, derivative)
    call gidx(9, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyj(xlk, ylk, xkj, ykj, xji, yji, derivative)
    call gidx(7, 8, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyj(xlk, zlk, xkj, zkj, xji, zji, derivative)
    call gidx(7, 9, ij)
    d2adxdy(ij) = derivative
    call get_d2adxjdyj(ylk, zlk, ykj, zkj, yji, zji, derivative)
    call gidx(8, 9, ij)
    d2adxdy(ij) = derivative

    ! i l

    call get_d2adxidxl(ykj,zkj,derivative)
    call gidx(1, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxl(zkj,xkj,derivative)
    call gidx(2, 11, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxl(xkj,ykj,derivative)
    call gidx(3, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyl(xkj,ykj,derivative)
    call gidx(1, 11, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyl(xkj,zkj,derivative)
    call gidx(1, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyl(zkj,ykj,derivative)
    call gidx(2, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyl(ykj,xkj,derivative)
    call gidx(2, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyl(zkj,xkj,derivative)
    call gidx(3, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyl(ykj,zkj,derivative)
    call gidx(3, 11, ij)
    d2adxdy(ij) = derivative
    ! j l
    call get_d2adxidxk(ykj, zkj, yji, zji, derivative)
    call gidx(4, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxk(zkj, xkj, zji, xji, derivative)
    call gidx(5, 11, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxk(xkj, ykj, xji, yji, derivative)
    call gidx(6, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(ykj, xkj, yji, xji, derivative)
    call gidx(4, 11, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(zkj, xkj, zji, xji, derivative)
    call gidx(4, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(zkj, ykj, zji, yji, derivative)
    call gidx(5, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(xkj, ykj, xji, yji,derivative)
    call gidx(5, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(xkj, zkj, xji, zji, derivative)
    call gidx(6, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyk(ykj, zkj, yji, zji, derivative)
    call gidx(6, 11, ij)
    d2adxdy(ij) = derivative

    ! k l
    call get_d2adxidxj(ykj, zkj, yji, zji, derivative)
    call gidx(7, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxj(xkj, zkj, xji, zji, derivative)
    call gidx(8, 11, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidxj(xkj, ykj, xji, yji, derivative)
    call gidx(9, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(xji, yji, xkj, ykj, derivative)
    call gidx(7, 11, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(xji, zji,xkj, zkj, derivative)
    call gidx(7, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(yji, zji, ykj, zkj, derivative)
    call gidx(8, 12, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(yji, xji, ykj, xkj,derivative)
    call gidx(8, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(zji, xji, zkj, xkj, derivative)
    call gidx(9, 10, ij)
    d2adxdy(ij) = derivative
    call get_d2adxidyj(zji, yji, zkj, ykj, derivative)
    call gidx(9, 11, ij)
    d2adxdy(ij) = derivative 

    ! l l = 0            
    
end subroutine get_ahessian


subroutine get_d2adxjdxj(yji, zji, ykj, zkj, ylk, zlk, derivative)
real(8), intent(in) :: yji, zji, ykj, zkj, ylk, zlk
real(8), intent(out) :: derivative
derivative = -2*ylk*(yji+ykj)-2*zlk*(zji+zkj)
end subroutine get_d2adxjdxj

subroutine get_d2adxjdyj(xji, yji, xkj, ykj, xlk, ylk, derivative)
real(8), intent(in) :: xji, yji, xkj, ykj, xlk, ylk
real(8), intent(out) :: derivative
derivative = xlk*(yji+ykj)+ylk*(xji+xkj)
end subroutine get_d2adxjdyj

subroutine get_d2adxidxj(ykj, zkj, ylk, zlk, derivative)
real(8), intent(in) :: ykj, zkj, ylk, zlk
real(8), intent(out) :: derivative
derivative = ykj*ylk+zkj*zlk
end subroutine get_d2adxidxj

subroutine get_d2adxidyj(xkj, ykj, xlk, ylk, derivative)
real(8), intent(in) :: xkj, ykj, xlk, ylk
real(8), intent(out) :: derivative
derivative = xkj*ylk-2*xlk*ykj
end subroutine get_d2adxidyj

subroutine get_d2adxidxk(ykj, zkj, ylk, zlk, derivative)
real(8), intent(in) :: ykj, zkj, ylk, zlk
real(8), intent(out) :: derivative
derivative = -ykj*(ykj+ylk)-zkj*(zkj+zlk)
end subroutine get_d2adxidxk

subroutine get_d2adxidyk(xkj, ykj, xlk, ylk,derivative)
real(8), intent(in) :: xkj, ykj, xlk, ylk
real(8), intent(out) :: derivative
derivative = -xkj*ylk+xlk*ykj+ykj*(xkj+xlk)
end subroutine get_d2adxidyk

subroutine get_d2adxidxl(ykj,zkj,derivative)
real(8), intent(in) :: ykj,zkj
real(8), intent(out) :: derivative
derivative = ykj**2+zkj**2
end subroutine get_d2adxidxl

subroutine get_d2adxidyl(xkj,ykj,derivative)
real(8), intent(in) :: xkj,ykj
real(8), intent(out) :: derivative
derivative = -xkj*ykj
end subroutine get_d2adxidyl

subroutine get_d2adxjdxk(yji,zji,ykj,zkj,ylk,zlk,derivative)
real(8), intent(in) :: yji,zji,ykj,zkj,ylk,zlk
real(8), intent(out) :: derivative
derivative = yji*ylk+zji*zlk+(yji+ykj)*(ykj+ylk)+(zji+zkj)*(zkj+zlk)
end subroutine get_d2adxjdxk

subroutine get_d2adxjdyk(xji,yji,xkj,ykj,xlk,ylk,derivative)
real(8), intent(in) :: xji,yji,xkj,ykj,xlk,ylk
real(8), intent(out) :: derivative
derivative = xji*ykj-xji*ylk-xkj*yji+xkj*ylk-xlk*ykj-(xkj+xlk)*(yji+ykj)
end subroutine get_d2adxjdyk


subroutine get_agradient(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,dadx)
    real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
    real(8), intent(out) :: dadx(12)
    real(8) :: ddx, ddy, ddz

    dadx = 0.0_wp

    call get_dadxi(xkj,ykj,zkj,xlk,ylk,zlk,ddx)
    call get_dadxi(ykj,zkj,xkj,ylk,zlk,xlk,ddy)
    call get_dadxi(zkj,xkj,ykj,zlk,xlk,ylk,ddz)

    dadx(1) = ddx
    dadx(2) = ddy
    dadx(3) = ddz 
    
    call get_dadxj(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,ddx)
    call get_dadxj(yji,zji,xji,ykj,zkj,xkj,ylk,zlk,xlk,ddy)
    call get_dadxj(zji,xji,yji,zkj,xkj,ykj,zlk,xlk,ylk,ddz)


    dadx(4) = ddx
    dadx(5) = ddy
    dadx(6) = ddz 
    
    call get_dadxk(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,ddx)
    call get_dadxk(yji,zji,xji,ykj,zkj,xkj,ylk,zlk,xlk,ddy)
    call get_dadxk(zji,xji,yji,zkj,xkj,ykj,zlk,xlk,ylk,ddz)

    dadx(7) = ddx
    dadx(8) = ddy
    dadx(9) = ddz

    call get_dadxl(xkj,ykj,zkj,xji,yji,zji,xlk,ylk,zlk,ddx)
    call get_dadxl(ykj,zkj,xkj,yji,zji,xji,ylk,zlk,xlk,ddy)
    call get_dadxl(zkj,xkj,ykj,zji,xji,yji,zlk,xlk,ylk,ddz)

    dadx(10) = ddx
    dadx(11) = ddy
    dadx(12) = ddz

end subroutine get_agradient


subroutine get_dadxi(xkj,ykj,zkj,xlk,ylk,zlk,derivative)
real(8), intent(in) :: xkj,ykj,zkj,xlk,ylk,zlk
real(8), intent(out) :: derivative
derivative = -ykj*(xkj*ylk - xlk*ykj) + zkj*(-xkj*zlk + xlk*zkj)
end subroutine get_dadxi

subroutine get_dadxj(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,derivative)
real(8), intent(in) :: xji,yji,xkj,ykj,zkj,zji,xlk,ylk,zlk
real(8), intent(out) :: derivative
real(8) :: term1, term2, term3, term4, term5, term6
    term1= yji*(xkj*ylk-xlk*ykj)
    term2 = ykj*(xkj*ylk-xlk*ykj)
    term3 = ylk*(xji*ykj-xkj*yji)
    term4 = zji*(xkj*zlk-xlk*zkj)
    term5 = zkj*(xkj*zlk-xlk*zkj)
    term6 = zlk*(xji*zkj-xkj*zji)
    derivative = term1+term2-term3+term4+term5-term6
end subroutine get_dadxj

subroutine get_dadxk(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,derivative)
real(8), intent(in) :: xji,yji,xkj,ykj,zkj,zji,xlk,ylk,zlk
real(8), intent(out) :: derivative
real(8) :: term1, term2, term3, term4, term5, term6
    term1 = yji *(xkj *ylk - xlk *ykj)
    term2 = ykj *(xji* ykj - xkj* yji)
    term3 = ylk *(xji *ykj - xkj* yji)
    term4 = zji* (xkj* zlk - xlk* zkj)
    term5 = zkj* (xji* zkj - xkj* zji)
    term6 = zlk *(xji* zkj - xkj* zji)
    derivative = -term1+term2+term3-term4+term5+term6
end subroutine get_dadxk

subroutine get_dadxl(xkj,ykj,zkj,xji,yji,zji,xlk,ylk,zlk,derivative)
    real(8), intent(in) :: xkj,ykj,zkj,xji,yji,zji,xlk,ylk,zlk
    real(8), intent(out) :: derivative
    derivative = -ykj*(xji*ykj - xkj*yji) + zkj*(-xji*zkj + xkj*zji)
end subroutine get_dadxl


end module a_dihedral_derivatives

module force_field_energy

use fortran_helper, only :  get_R_ij, get_theta_ijk, get_cosphi_ijkl, get_sinphi_ijkl

implicit none
public :: get_energy

contains

subroutine get_energy(n_atoms, geometry, bonds, ideal_bonds, angles, ideal_angles, &
    dihedrals, ideal_dihedrals, repulsion, charges, k_bonds, k_angles, k_dihedrals, energy)

    intrinsic :: selected_real_kind
    integer, parameter :: wp = selected_real_kind(15)
    real(8), intent(in) :: geometry(:, :), ideal_bonds(:), ideal_angles(:), ideal_dihedrals(:), charges(:)
    integer, intent(in) ::  n_atoms, bonds(:, :), angles(:, :), dihedrals(:,:), repulsion(:,:)
    real(8), intent(in) :: k_bonds, k_angles, k_dihedrals
    real(8), intent(out) :: energy
    real(8) :: Rij, thetaijk, sinphi_ijkl, cosphi_ijkl, E_bond, E_angle, E_dihedral, E_rep
    integer :: n, i, j, k,l

    energy = 0.0_wp
    E_bond = 0.0_wp
    E_angle = 0.0_wp
    E_dihedral = 0.0_wp
    E_rep = 0.0_wp

    do n=1, size(ideal_bonds)

        i = bonds(1, n)
        j = bonds(2, n)
        call get_R_ij(geometry, i, j, Rij)

        E_bond = E_bond + k_bonds*(ideal_bonds(n)-Rij)**2

    enddo

    do n=1, size(ideal_angles)

        i = angles(1, n)
        j = angles(2, n)
        k = angles(3, n)

        call get_theta_ijk(geometry, i, j, k, thetaijk)

        E_angle = E_angle + k_angles*(ideal_angles(n)-thetaijk)**2

    enddo

    do n=1, size(ideal_dihedrals)

        i = dihedrals(1, n)
        j = dihedrals(2, n)
        k = dihedrals(3, n)
        l = dihedrals(4, n)

        call get_cosphi_ijkl(geometry, i, j, k,l, cosphi_ijkl)
        call get_sinphi_ijkl(geometry, i, j, k,l, sinphi_ijkl)

        E_dihedral = E_dihedral + k_dihedrals*((cos(ideal_dihedrals(n))-cosphi_ijkl)**2 &
                + (sin(ideal_dihedrals(n))-sinphi_ijkl)**2)
    enddo

    do n=1, size(charges)

        i = repulsion(1, n)
        j = repulsion(2, n)

        call get_R_ij(geometry, i, j, Rij)

        E_rep = E_rep + charges(n)/(Rij)

    enddo

    energy = E_bond + E_angle + E_dihedral + E_rep

end subroutine get_energy

end module force_field_energy

module d_dihedral_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_d_dihedral_derivatives
integer, parameter :: wp = selected_real_kind(15)

contains

subroutine get_d_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,dddx,d2ddxdy)
     real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
     real(8), intent(out) :: dddx(12), d2ddxdy(78)
     real(8) :: ddx, ddy, ddz
    integer :: i

    call get_dgradient(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, dddx)

    call get_dhessian(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,d2ddxdy)
    
end subroutine get_d_dihedral_derivatives

subroutine get_dhessian(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,d2ddxdy)
     real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
     real(8), intent(out) :: d2ddxdy(78)
     real(8) :: derivative
    integer :: ij

    d2ddxdy = 0.0_wp
    ! i i = 0

    !j j
    call get_d2ddxjdxj(xji, yji, zji, xkj, ykj, zkj, xlk, ylk, zlk, derivative)
    call gidx(4, 4, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdxj(yji, zji, xji, ykj, zkj, xkj, ylk, zlk, xlk,derivative)
    call gidx(5, 5, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdxj(zji, xji, yji, zkj, xkj, ykj, zlk, xlk, ylk, derivative)
    call gidx(6, 6, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdyj(xji, yji, zji, xkj, ykj, zkj, xlk, ylk, zlk, derivative)
    call gidx(4, 5, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdyj(zji, xji, yji, zkj, xkj, ykj, zlk, xlk, ylk, derivative)
    call gidx(4, 6, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdyj(yji, zji, xji, ykj, zkj, xkj, ylk, zlk,xlk, derivative)
    call gidx(5, 6, ij)
    d2ddxdy(ij) = derivative

    !i j
    call get_d2ddxidxj(xkj,ykj, zkj, ylk, zlk, derivative)
    call gidx(1, 4, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidxj(ykj,zkj, xkj, zlk, xlk, derivative) 
    call gidx(2, 5, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidxj(zkj,xkj,ykj, xlk, ylk, derivative) 
    call gidx(3, 6, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyj(xkj,ykj,zkj, xlk, ylk, zlk, derivative)
    call gidx(1, 5, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyj(xkj, zkj, ykj, xlk, zlk, ylk, derivative)
    call gidx(1, 6, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyj(ykj, zkj,xkj, ylk, zlk, xlk, derivative)
    call gidx(2, 6, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyj(ykj, xkj,zkj, ylk, xlk, zlk, derivative)
    call gidx(2, 4, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyj(zkj, xkj, ykj, zlk, xlk, ylk, derivative)
    call gidx(3, 4, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyj(zkj, ykj,xkj, zlk, ylk, xlk, derivative)
    call gidx(3, 5, ij)
    d2ddxdy(ij) = -derivative

    ! i k 

    call get_d2ddxidxk(xkj,ykj, zkj, ylk, zlk, derivative)
    call gidx(1, 7, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidxk(ykj,zkj, xkj, zlk, xlk, derivative)
    call gidx(2, 8, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidxk(zkj,xkj, ykj, xlk, ylk, derivative)
    call gidx(3, 9, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyk(xkj, ykj, zkj, ylk,zlk, derivative)
    call gidx(1, 8, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyk(xkj, zkj, ykj, zlk,ylk, derivative)
    call gidx(1, 9, ij)
    d2ddxdy(ij) = -derivative 
    call get_d2ddxidyk(ykj, zkj, xkj, zlk, xlk, derivative)
    call gidx(2, 9, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyk(ykj, xkj, zkj, xlk,zlk,derivative)
    call gidx(2, 7, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyk(zkj, xkj, ykj, xlk,ylk, derivative)
    call gidx(3, 7, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyk(zkj, ykj, xkj, ylk, xlk, derivative)
    call gidx(3, 8, ij)
    d2ddxdy(ij) = -derivative

    ! j k
    call get_d2ddxjdxk(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,derivative)
    call gidx(4, 7, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdxk(yji,xji,zji,ykj,xkj,zkj,ylk,xlk,zlk,derivative)
    call gidx(5, 8, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdxk(zji,xji,yji,zkj,xkj,ykj,zlk,xlk,ylk,derivative)
    call gidx(6, 9, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdyk(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,derivative)
    call gidx(4, 8, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdyk(xji,zji,yji,xkj,zkj,ykj,xlk,zlk,ylk,derivative)
    call gidx(4, 9, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdyk(yji,zji,xji,ykj,zkj,xkj,ylk,zlk,xlk,derivative)
    call gidx(5, 9, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdyk(yji,xji,zji,ykj,xkj,zkj,ylk,xlk,zlk,derivative)
    call gidx(5, 7, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdyk(zji,xji,yji,zkj,xkj,ykj,zlk,xlk,ylk,derivative)
    call gidx(6, 7, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxjdyk(zji,yji,xji,zkj,ykj,xkj,zlk,ylk,xlk,derivative)
    call gidx(6, 8, ij)
    d2ddxdy(ij) = -derivative

    ! k k 

    call get_d2ddxjdxj(xlk, ylk, zlk, xkj,ykj, zkj, xji, yji, zji, derivative)
    call gidx(7, 7, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdxj(ylk, zlk, xlk, ykj, zkj, xkj, yji, zji, xji, derivative)
    call gidx(8, 8, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdxj(zlk, xlk, ylk, zkj, xkj, ykj, zji, xji, yji, derivative)
    call gidx(9, 9, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdyj(xlk, ylk, zlk,xkj, ykj, zkj, xji, yji, zji, derivative)
    call gidx(7, 8, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdyj(zlk, xlk, ylk,zkj, xkj, ykj,zji, xji, yji,derivative)
    call gidx(7, 9, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxjdyj( ylk, zlk,xlk, ykj, zkj, xkj, yji, zji, xji, derivative)
    call gidx(8, 9, ij)
    d2ddxdy(ij) = -derivative

    ! i l

    call get_d2ddxidyl(xkj,ykj,zkj,derivative)
    call gidx(1, 11, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyl(xkj,zkj,ykj,derivative)
    call gidx(1, 12, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyl(ykj,zkj,xkj,derivative)
    call gidx(2, 12, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyl(ykj,xkj,zkj,derivative)
    call gidx(2, 10, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyl(zkj,xkj,ykj,derivative)
    call gidx(3, 10, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyl(zkj,ykj,xkj,derivative)
    call gidx(3, 11, ij)
    d2ddxdy(ij) = -derivative
    ! j l
    call get_d2ddxidxk(xkj,ykj, zkj, yji, zji, derivative)
    call gidx(4, 10, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidxk(ykj,zkj, xkj, zji, xji, derivative)
    call gidx(5, 11, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidxk(zkj,xkj, ykj, xji, yji, derivative)
    call gidx(6, 12, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyk(ykj, xkj, zkj, xji,zji, derivative)
    call gidx(4, 11, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyk(zkj, xkj, ykj, xji,yji, derivative)
    call gidx(4, 12, ij)
    d2ddxdy(ij) = -derivative 
    call get_d2ddxidyk(zkj, ykj, xkj, yji, xji, derivative)
    call gidx(5, 12, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyk(xkj, ykj, zkj, yji,zji,derivative)
    call gidx(5, 10, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyk(xkj, zkj, ykj, zji,yji, derivative)
    call gidx(6, 10, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyk(ykj, zkj, xkj, zji, xji, derivative)
    call gidx(6, 11, ij)
    d2ddxdy(ij) = -derivative

    ! k l
    call get_d2ddxidxj(xkj,ykj, zkj, yji, zji, derivative)
    call gidx(7, 10, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidxj(ykj,zkj, xkj, zji, xji, derivative)
    call gidx(8, 11, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidxj(zkj, xkj, ykj, xji, yji, derivative)
    call gidx(9, 12, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyj(ykj, xkj, zkj, yji, xji, zji, derivative)
    call gidx(7, 11, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyj(zkj,xkj,ykj, zji, xji, yji, derivative)
    call gidx(7, 12, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyj(zkj,ykj,xkj, zji, yji, xji, derivative)
    call gidx(8, 12, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyj(xkj,ykj, zkj, xji, yji, zji, derivative)
    call gidx(8, 10, ij)
    d2ddxdy(ij) = -derivative
    call get_d2ddxidyj(xkj,zkj,ykj, xji, zji, yji, derivative)
    call gidx(9, 10, ij)
    d2ddxdy(ij) = derivative
    call get_d2ddxidyj(ykj,zkj,xkj, yji, zji, xji, derivative)
    call gidx(9, 11, ij)
    d2ddxdy(ij) = -derivative 

    ! l l = 0            
    
end subroutine get_dhessian

subroutine get_d2ddxjdxj(xji, yji, zji, xkj, ykj, zkj, xlk, ylk, zlk, derivative)
 real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj, xlk, ylk, zlk
 real(8), intent(out) :: derivative
 real(8) :: enumerator, denominator
enumerator = - 2*xkj*(xkj**2 + ykj**2 + zkj**2)*(yji*zlk + ykj*zlk - ylk*zji - ylk*zkj) &
            + (ykj**2 + zkj**2)*(xji*(ykj*zlk - ylk*zkj) - yji*(xkj*zlk - xlk*zkj) &
            + zji*(xkj*ylk - xlk*ykj))
denominator = (xkj**2 + ykj**2 + zkj**2)**1.5_wp
derivative = enumerator/denominator
end subroutine get_d2ddxjdxj

subroutine get_d2ddxjdyj(xji, yji, zji, xkj, ykj, zkj, xlk, ylk, zlk, derivative)
 real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj, xlk, ylk, zlk
 real(8), intent(out) :: derivative
 real(8) :: enumerator, denominator
enumerator = - xkj*ykj*(xji*(ykj*zlk - ylk*zkj) - yji*(xkj*zlk - xlk*zkj) + &
             zji*(xkj*ylk - xlk*ykj)) - (- xkj*(xji*zlk + xkj*zlk - xlk*zji - xlk*zkj) &
            + ykj*(yji*zlk + ykj*zlk - ylk*zji - ylk*zkj))*(xkj**2 + ykj**2 + zkj**2)
denominator = (xkj**2 + ykj**2 + zkj**2)**1.5_wp
derivative = enumerator/denominator
end subroutine get_d2ddxjdyj

subroutine get_d2ddxidxj(xkj,ykj, zkj, ylk, zlk, derivative)
 real(8), intent(in) :: xkj, ykj, zkj, ylk, zlk
 real(8), intent(out) :: derivative
derivative = xkj*(ykj*zlk - ylk*zkj)/(sqrt(xkj**2 + ykj**2 + zkj**2))
end subroutine get_d2ddxidxj

subroutine get_d2ddxidyj(xkj, ykj,zkj, xlk, ylk, zlk, derivative)
intrinsic :: sqrt
 real(8), intent(in) :: xkj, ykj,zkj, xlk, ylk, zlk
 real(8), intent(out) :: derivative
derivative = (ykj*(ykj*zlk - ylk*zkj) + zlk*(xkj**2 + ykj**2 + zkj**2))/(sqrt(xkj**2 + ykj**2 + zkj**2))
end subroutine get_d2ddxidyj

subroutine get_d2ddxidxk(xkj,ykj, zkj, ylk, zlk, derivative)
intrinsic :: sqrt
 real(8), intent(in) :: xkj,ykj, zkj, ylk, zlk
 real(8), intent(out) :: derivative
derivative = xkj*(- ykj*zlk + ylk*zkj)/sqrt(xkj**2 + ykj**2 + zkj**2)
end subroutine get_d2ddxidxk

subroutine get_d2ddxidyk(xkj, ykj, zkj, ylk,zlk, derivative)
 real(8), intent(in) :: xkj, ykj, zkj, ylk,zlk
 real(8), intent(out) :: derivative
derivative = (- ykj*(ykj*zlk - ylk*zkj) - (zkj + zlk)*(xkj**2 + ykj**2 + zkj**2))/(sqrt(xkj**2 + ykj**2 + zkj**2))
end subroutine get_d2ddxidyk


subroutine get_d2ddxidyl(xkj,ykj,zkj,derivative)
 real(8), intent(in) :: xkj,ykj,zkj
 real(8), intent(out) :: derivative
derivative = zkj*sqrt(xkj**2+ykj**2+zkj**2)
end subroutine get_d2ddxidyl

subroutine get_d2ddxjdxk(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,derivative)
intrinsic :: sqrt
 real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
 real(8), intent(out) :: derivative
 real(8) :: enumerator, denominator
enumerator = xkj**2*(xji*(ykj*zlk - ylk*zkj) - yji*(xkj*zlk - xlk*zkj) + zji*(xkj*ylk - xlk*ykj)) &
            - (xkj**2 + ykj**2 + zkj**2)*(xji*(ykj*zlk - ylk*zkj) + xkj*(- yji*(zkj + zlk) + zji*(ykj + ylk)) & 
            - xkj*(yji*zlk + ykj*zlk - ylk*zji - ylk*zkj) - yji*(xkj*zlk - xlk*zkj) + zji*(xkj*ylk - xlk*ykj)) 
denominator = (xkj**2 + ykj**2 + zkj**2)**1.5_wp
derivative = enumerator/denominator
end subroutine get_d2ddxjdxk

subroutine get_d2ddxjdyk(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,derivative)
intrinsic :: sqrt
 real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
 real(8), intent(out) :: derivative
 real(8) :: enumerator, denominator
enumerator = xkj*ykj*(xji*(ykj*zlk - ylk*zkj) - yji*(xkj*zlk - xlk*zkj) + zji*(xkj*ylk - xlk*ykj)) &
             + (zji + zkj + zlk)*(xkj**2 + ykj**2 + zkj**2)**2 + (- xkj*(xji*(zkj + zlk) - zji*(xkj + xlk)) &
            + ykj*(yji*zlk + ykj*zlk - ylk*zji - ylk*zkj))*(xkj**2 + ykj**2 + zkj**2)
denominator = (xkj**2 + ykj**2 + zkj**2)**1.5_wp
derivative = enumerator/denominator
end subroutine get_d2ddxjdyk


subroutine get_dgradient(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, dddx)
     real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
     real(8), intent(out) :: dddx(12)
     real(8) :: ddx, ddy, ddz

    dddx = 0.0_wp

    call get_dddxi(xkj, ykj, zkj, ylk, zlk, ddx)
    call get_dddxi(ykj, zkj, xkj, zlk, xlk, ddy)
    call get_dddxi(zkj, xkj, ykj, xlk, ylk, ddz)

    dddx(1) = ddx
    dddx(2) = ddy
    dddx(3) = ddz 

    call get_dddxj(xkj, ykj, zkj, xlk,ylk, zlk, xji, yji, zji, ddx)
    call get_dddxj(ykj, zkj, xkj, ylk,zlk, xlk, yji, zji, xji, ddy)
    call get_dddxj(zkj, xkj, ykj, zlk, xlk, ylk, zji, xji, yji, ddz)

    dddx(4) = ddx
    dddx(5) = ddy
    dddx(6) = ddz 

    call get_dddxk(xkj, ykj, zkj, xlk, ylk, zlk, xji, yji, zji, ddx)
    call get_dddxk(ykj, zkj, xkj, ylk, zlk, xlk, yji, zji, xji, ddy)
    call get_dddxk(zkj, xkj, ykj, zlk, xlk, ylk, zji, xji, yji, ddz)

    dddx(7) = ddx
    dddx(8) = ddy
    dddx(9) = ddz 

    call get_dddxl(xkj, ykj, zkj, xji, yji, zji, ylk, zlk, ddx)
    call get_dddxl(ykj, zkj, xkj, yji, zji, xji, zlk, xlk, ddy)
    call get_dddxl(zkj, xkj, ykj, zji, xji, yji, xlk, ylk, ddz)

    dddx(10) = ddx
    dddx(11) = ddy
    dddx(12) = ddz 

end subroutine get_dgradient

subroutine get_dddxi(xkj, ykj, zkj, ylk, zlk, derivative)
    intrinsic :: sqrt
     real(8), intent(in) :: xkj, ykj, zkj, ylk, zlk
     real(8), intent(out) :: derivative

    derivative = -(ykj*zlk - ylk*zkj)*sqrt(xkj**2 + ykj**2 + zkj**2)

end subroutine get_dddxi

subroutine get_dddxj(xkj, ykj, zkj, xlk,ylk, zlk, xji, yji, zji, derivative)
    intrinsic :: sqrt
     real(8), intent(in) :: xkj, ykj, zkj, xlk, ylk, zlk, xji, yji, zji
     real(8), intent(out) :: derivative

    derivative = - (xkj * (xji * (ykj * zlk - ylk * zkj) + yji * (-xkj * zlk + xlk * zkj) + zji * (xkj * ylk - xlk * ykj))) / &
            sqrt(xkj**2 + ykj**2 + zkj**2) - (-yji * zlk + ylk * zji) * sqrt(xkj**2 + ykj**2 + zkj**2) +&
            (ykj * zlk - ylk * zkj) * sqrt(xkj**2 + ykj**2 + zkj**2)

end subroutine get_dddxj

subroutine get_dddxk(xkj, ykj, zkj, xlk, ylk, zlk, xji, yji, zji, derivative)
     real(8), intent(in) :: xkj, ykj, zkj, xlk, ylk, zlk, xji, yji, zji
     real(8), intent(out) :: derivative
    
    derivative = (xkj*(xji*(ykj*zlk - ylk*zkj) + yji*(-xkj*zlk + xlk*zkj) &
                + zji*(xkj*ylk - xlk*ykj)))/sqrt(xkj**2 + ykj**2 + zkj**2) - &
                (yji*zkj - ykj*zji)*sqrt(xkj**2 + ykj**2 + zkj**2) + (ylk*zji - yji*zlk)*sqrt(xkj**2 + ykj**2 + zkj**2)
end subroutine get_dddxk

subroutine get_dddxl(xkj, ykj, zkj, xji, yji, zji, ylk, zlk, derivative)
     real(8), intent(in) :: xkj, ykj, zkj, xji, yji, zji, ylk, zlk
     real(8), intent(out) :: derivative
    derivative = (yji * zkj - ykj * zji) * sqrt(xkj**2 + ykj**2 + zkj**2)
end subroutine get_dddxl

end module d_dihedral_derivatives

module inv_rij_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_inverse_distance_derivatives
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_inverse_distance_derivatives(xij,yij,zij,rij,dqdx,d2qdxdy)
    real(8), intent(in) :: xij,yij,zij,rij
    real(8), intent(out) :: dqdx(6),d2qdxdy(21)

    call get_qgradient(xij,yij,zij,rij,dqdx)
    call get_qhessian(xij,yij,zij,rij,d2qdxdy)

end subroutine get_inverse_distance_derivatives


subroutine get_qhessian(xij,yij,zij,rij,d2qdxdy)
    real(8), intent(in) :: xij,yij,zij, rij
    real(8), intent(out) :: d2qdxdy(21)
    real(8) :: derivative
    integer :: ij

    d2qdxdy = 0.0_wp

    call get_d2qdxidxi(xij, yij, zij, rij, derivative)
    call gidx(1, 1, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidxi(yij, zij, xij, rij, derivative)
    call gidx(2, 2, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidxi(zij, xij, yij, rij, derivative)
    call gidx(3, 3, ij)
    d2qdxdy(ij) = derivative

    call get_d2qdxidyi(xij, yij, rij, derivative)
    call gidx(1, 2, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidyi(xij, zij ,rij, derivative)
    call gidx(1, 3, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidyi(yij, zij ,rij, derivative)
    call gidx(2, 3, ij)
    d2qdxdy(ij) = derivative

    call get_d2qdxidxi(xij, yij, zij, rij, derivative)
    call gidx(4, 4, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidxi(yij, zij, xij, rij, derivative)
    call gidx(5, 5, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidxi(zij, xij, yij, rij, derivative)
    call gidx(6, 6, ij)
    d2qdxdy(ij) = derivative

    call get_d2qdxidyi(xij, yij, rij, derivative)
    call gidx(4, 5, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidyi(xij, zij ,rij, derivative)
    call gidx(4, 6, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidyi(yij, zij ,rij, derivative)
    call gidx(5, 6, ij)
    d2qdxdy(ij) = derivative

    call get_d2qdxidxj(xij, yij, zij,rij, derivative)
    call gidx(1, 4, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidxj(yij, zij, xij,rij, derivative)
    call gidx(2, 5, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidxj(zij, xij, yij,rij, derivative)
    call gidx(3, 6, ij)
    d2qdxdy(ij) = derivative

    call get_d2qdxidyj(xij, yij ,rij, derivative)
    call gidx(1, 5, ij)
    d2qdxdy(ij) = derivative
    call gidx(2, 4, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidyj(xij, zij ,rij, derivative)
    call gidx(1, 6, ij)
    d2qdxdy(ij) = derivative
    call gidx(3, 4, ij)
    d2qdxdy(ij) = derivative
    call get_d2qdxidyj(yij, zij ,rij, derivative)
    call gidx(2, 6, ij)
    d2qdxdy(ij) = derivative
    call gidx(3, 5, ij)
    d2qdxdy(ij) = derivative

end subroutine get_qhessian

subroutine get_d2qdxidxi(xij, yij, zij, rij, derivative)
real(8), intent(in) :: xij,yij, zij,rij
real(8), intent(out) :: derivative
derivative = (2*xij**2-yij**2-zij**2)/rij**5
end subroutine get_d2qdxidxi

subroutine get_d2qdxidyi(xij, yij, rij, derivative)
real(8), intent(in) :: xij, yij, rij
real(8), intent(out) :: derivative
derivative = (3*xij*yij)/rij**5
end subroutine get_d2qdxidyi

subroutine get_d2qdxidxj(xij, yij, zij,rij, derivative)
real(8), intent(in) :: xij, yij, zij, rij
real(8), intent(out) :: derivative
derivative = (-2*xij**2+yij**2+zij**2)/rij**5
end subroutine get_d2qdxidxj

subroutine get_d2qdxidyj(xij, yij,rij, derivative)
real(8), intent(in) :: xij, yij, rij
real(8), intent(out) :: derivative
derivative = -(3*xij*yij)/rij**5
end subroutine get_d2qdxidyj

subroutine get_qgradient(xij,yij,zij,rij,dqdx)
    real(8), intent(in) :: xij,yij,zij, rij
    real(8), intent(out) :: dqdx(6)
    real(8) :: ddx, ddy, ddz

    dqdx = 0.0_wp

    call get_dqdxi(xij,rij,ddx)
    call get_dqdxi(yij,rij,ddy)
    call get_dqdxi(zij,rij,ddz)

    dqdx(1) = ddx
    dqdx(2) = ddy
    dqdx(3) = ddz 

    call get_dqdxi(xij,rij,ddx)
    call get_dqdxi(yij,rij,ddy)
    call get_dqdxi(zij,rij,ddz)

    dqdx(4) = -ddx
    dqdx(5) = -ddy
    dqdx(6) = -ddz 

end subroutine get_qgradient

subroutine get_dqdxi(xij,rij,derivative)
    real(8), intent(in) :: xij, rij
    real(8), intent(out) :: derivative
    derivative = -xij/rij**3
end subroutine get_dqdxi

end module inv_rij_derivatives

module fortran_helper

implicit none
public :: gidx, get_R_ij, get_theta_ijk, get_cosphi_ijkl, get_sinphi_ijkl, get_aijkl, get_bijk, get_cjkl, get_dijkl
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine gidx(i, j, ij)
    integer, intent(in) :: i, j
    integer, intent(out) :: ij
    if (i < j) then
        ij = (j - 1) * j  / 2 + i 
    else
        ij = (i - 1)* i / 2 + j 
    endif
end subroutine gidx

subroutine get_R_ij(geometry, i, j, R_ij)

    intrinsic :: sqrt   

    real(8), intent(in) :: geometry(:, :)

    integer, intent(in) :: i, j

    real(8), intent(out) :: R_ij

    real(8) :: x_ij, y_ij, z_ij

    x_ij = geometry(1,i)-geometry(1,j)
    y_ij = geometry(2,i)-geometry(2,j)
    z_ij = geometry(3,i)-geometry(3,j)

    R_ij = sqrt(x_ij**2 + y_ij**2 + z_ij**2)

end subroutine get_R_ij

subroutine get_theta_ijk(geometry, i, j, k, theta)

    intrinsic :: dot_product, acos

    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k
    real(8), intent(out) :: theta
    real(8) :: r_ij(3), r_kj(3)
    real(8) :: numerator,  denominator, norm_r_ij, norm_r_kj

    r_ij = (/ geometry(1,i)-geometry(1,j), geometry(2,i)-geometry(2,j), geometry(3,i)-geometry(3,j) /)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j) /)

    call get_l2norm(r_ij, norm_r_ij)

    call get_l2norm(r_kj, norm_r_kj)

    numerator = dot_product(r_ij, r_kj)

    denominator = norm_r_ij*norm_r_kj

    theta = acos(numerator/denominator)

end subroutine get_theta_ijk

subroutine get_aijk(geometry, i, j, k, aijk)

    intrinsic :: dot_product
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k
    real(8), intent(out) :: aijk
    real(8) :: r_ij(3), r_kj(3)

    r_ij = (/ geometry(1,i)-geometry(1,j), geometry(2,i)-geometry(2,j), geometry(3,i)-geometry(3,j)/)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j)/)

    aijk = dot_product(r_ij, r_kj)

end subroutine get_aijk

subroutine get_bij(geometry, i, j, bij)

    intrinsic :: dot_product
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j
    real(8), intent(out) :: bij
    real(8) :: r_ij(3)

    r_ij = (/ geometry(1,i)-geometry(1,j), geometry(2,i)-geometry(2,j), geometry(3,i)-geometry(3,j)/)

    call get_l2norm(r_ij, bij)

end subroutine get_bij

subroutine get_aijkl(geometry, i, j, k, l, aijkl)
    intrinsic :: dot_product
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k, l
    real(8), intent(out) :: aijkl
    real(8) :: r_ji(3), r_kj(3), r_lk(3), cross_jikj(3), cross_kjlk(3)

    r_ji = (/ geometry(1,j)-geometry(1,i), geometry(2,j)-geometry(2,i), geometry(3,j)-geometry(3,i)/)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j)/)
    
    r_lk = (/ geometry(1,l)-geometry(1,k), geometry(2,l)-geometry(2,k), geometry(3,l)-geometry(3,k)/)

    call cross_product(r_ji, r_kj, cross_jikj)

    call cross_product(r_kj, r_lk, cross_kjlk)

    aijkl = dot_product(cross_jikj, cross_kjlk)

end subroutine get_aijkl

subroutine get_bijk(geometry, i, j, k, bijk)
    intrinsic :: dot_product
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k
    real(8), intent(out) :: bijk
    real(8) :: r_ji(3), r_kj(3), cross_jikj(3)

    r_ji = (/ geometry(1,j)-geometry(1,i), geometry(2,j)-geometry(2,i), geometry(3,j)-geometry(3,i)/)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j)/)
    
    call cross_product(r_ji, r_kj, cross_jikj)

    call get_l2norm(cross_jikj, bijk)

end subroutine get_bijk

subroutine get_cjkl(geometry, j, k,l, cjkl)
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: j,k,l
    real(8), intent(out) :: cjkl
    real(8) ::r_kj(3), r_lk(3), cross_kjlk(3)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j)/)

    r_lk = (/ geometry(1,l)-geometry(1,k), geometry(2,l)-geometry(2,k), geometry(3,l)-geometry(3,k)/)
    
    call cross_product(r_kj, r_lk, cross_kjlk)

    call get_l2norm(cross_kjlk, cjkl)

end subroutine get_cjkl

subroutine get_dijkl(geometry, i, j, k, l, dijkl)
    intrinsic :: dot_product
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k, l
    real(8), intent(out) :: dijkl
    real(8) :: r_ji(3), r_kj(3), r_lk(3), cross_jikj(3), cross_kjlk(3)
    real(8) :: norm_r_kj,dot_jikjlk

    r_ji = (/ geometry(1,j)-geometry(1,i), geometry(2,j)-geometry(2,i), geometry(3,j)-geometry(3,i)/)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j)/)
    
    r_lk = (/ geometry(1,l)-geometry(1,k), geometry(2,l)-geometry(2,k), geometry(3,l)-geometry(3,k)/)

    call cross_product(r_ji, r_kj, cross_jikj)

    call cross_product(r_kj, r_lk, cross_kjlk)

    call get_l2norm(r_kj, norm_r_kj)

    dot_jikjlk = dot_product(r_ji, cross_kjlk)

    dijkl = norm_r_kj*dot_jikjlk

end subroutine get_dijkl



subroutine get_cosphi_ijkl(geometry, i, j, k, l, cosphi)
    intrinsic :: dot_product
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k, l
    real(8), intent(out) :: cosphi
    real(8) :: r_ji(3), r_kj(3), r_lk(3), cross_jikj(3), cross_kjlk(3)
    real(8) :: numerator, denominator, norm_cross_jikj, norm_cross_kjlk

    r_ji = (/ geometry(1,j)-geometry(1,i), geometry(2,j)-geometry(2,i), geometry(3,j)-geometry(3,i)/)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j)/)
    
    r_lk = (/ geometry(1,l)-geometry(1,k), geometry(2,l)-geometry(2,k), geometry(3,l)-geometry(3,k)/)

    call cross_product(r_ji, r_kj, cross_jikj)

    call cross_product(r_kj, r_lk, cross_kjlk)

    numerator = dot_product(cross_jikj, cross_kjlk)

    call get_l2norm(cross_jikj, norm_cross_jikj)

    call get_l2norm(cross_kjlk, norm_cross_kjlk)

    denominator = norm_cross_jikj * norm_cross_kjlk

    cosphi = numerator/denominator

end subroutine get_cosphi_ijkl

subroutine get_sinphi_ijkl(geometry, i, j, k, l, sinphi)
    intrinsic :: dot_product
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k, l
    real(8), intent(out) :: sinphi
    real(8) :: r_ji(3), r_kj(3), r_lk(3), cross_jikj(3), cross_kjlk(3)
    real(8) :: numerator, denominator, norm_cross_jikj, norm_cross_kjlk, norm_r_kj,dot_jikjlk

    r_ji = (/ geometry(1,j)-geometry(1,i), geometry(2,j)-geometry(2,i), geometry(3,j)-geometry(3,i)/)

    r_kj = (/ geometry(1,k)-geometry(1,j), geometry(2,k)-geometry(2,j), geometry(3,k)-geometry(3,j)/)
    
    r_lk = (/ geometry(1,l)-geometry(1,k), geometry(2,l)-geometry(2,k), geometry(3,l)-geometry(3,k)/)

    call cross_product(r_ji, r_kj, cross_jikj)

    call cross_product(r_kj, r_lk, cross_kjlk)

    call get_l2norm(r_kj, norm_r_kj)

    dot_jikjlk = dot_product(r_ji, cross_kjlk)

    numerator = norm_r_kj*dot_jikjlk

    call get_l2norm(cross_jikj, norm_cross_jikj)

    call get_l2norm(cross_kjlk, norm_cross_kjlk)

    denominator = norm_cross_jikj * norm_cross_kjlk

    sinphi = numerator/denominator

end subroutine get_sinphi_ijkl

subroutine cross_product(vec1, vec2, vec3)

    real(8), intent(in) :: vec1(3), vec2(3)
    real(8), intent(out) :: vec3(3)

    vec3(1) = vec1(2) * vec2(3) - vec1(3) * vec2(2)
    vec3(2) = vec1(3) * vec2(1) - vec1(1) * vec2(3)
    vec3(3) = vec1(1) * vec2(2) - vec1(2) * vec2(1)
    
end subroutine cross_product

subroutine get_l2norm(vec1, norm)

    intrinsic :: sqrt, selected_real_kind
    integer, parameter :: wp = selected_real_kind(15)
    real(8), intent(in) :: vec1(:)
    real(8), intent(out) :: norm
    integer :: i

    norm = 0.0_wp

    do i=1, size(vec1)
        norm = norm + vec1(i)**2
    enddo

    norm = sqrt(norm)

end subroutine

end module fortran_helper

module unsaturated_graph
implicit none
public :: get_combinations, get_matching
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_combinations(n_atoms, bonds, n_bonds, k, combinations)
    integer, intent(in) :: n_atoms
    integer, intent(in) :: n_bonds
    integer, intent(in) :: k
    integer, intent(in) :: bonds(:,:)
    integer, intent(out) :: combinations(2,k,n_bonds)
    integer :: i
    integer :: matching(2,k)

    do i=1, n_bonds
        call get_matching(n_atoms, i, bonds, k, matching)
        !write(*,*) "Final matching", matching
        combinations(:,:,i) = matching
    enddo

end subroutine get_combinations

subroutine get_matching(n_atoms, starting_id, bonds, k, matching)
    implicit none
    integer, intent(in), dimension(:, :) :: bonds
    integer, intent(in) :: n_atoms, starting_id, k
    integer, intent(out) :: matching(:,:)

    integer :: edge_id, i, j, n_degenerate_atoms, lowest_degree
    integer, dimension(:), allocatable :: degrees
    integer :: next_edge(2)
    integer, dimension(:), allocatable :: lowest_degree_atoms
    integer, dimension(:,:), allocatable :: next_edges
    logical :: success
    integer, dimension(:), allocatable :: visited

    allocate(visited(n_atoms))

    allocate(degrees(n_atoms))

    matching = 0

    matching(:, 1) = bonds(:, starting_id)

    edge_id = 2

    visited = 0
    visited(matching(1, 1)) = 1
    visited(matching(2, 1)) = 1

    do i = 1, k

        !write(*,*) i, "matching", matching
        !write(*,*) i, "visited", visited

        call get_degrees(bonds, visited, degrees)

        !write(*,*) i, "th degrees", degrees

        call get_lowest_degree(degrees, visited, n_degenerate_atoms, lowest_degree, success)

        if (.not. success) then
            return
        end if

        allocate(lowest_degree_atoms(n_degenerate_atoms))

        call get_lowest_degree_atoms(degrees, visited, lowest_degree, lowest_degree_atoms)
        
        !write(*,*) i, "th lowest degree atoms", lowest_degree_atoms

        !allocate(next_edges(2, n_degenerate_atoms))

        do j=1, size(lowest_degree_atoms)

            call get_next_edge_for_atom(lowest_degree_atoms(j), bonds, visited, degrees, next_edge, success)

            if (.not. success) then

                cycle

            else
                matching(:, edge_id) = next_edge
                visited(next_edge(1)) = 1
                visited(next_edge(2)) = 1
                edge_id = edge_id + 1
                EXIT
            end if
        end do

        deallocate(lowest_degree_atoms)

    end do

    deallocate(visited)
end subroutine get_matching

!subroutine get_matching(n_atoms, starting_edge_id, bonds, k, matching)

!> Calculates the degree of a given atom in a molecule.
!! Inputs:
!!   atom: integer, the index of the atom whose degree is to be calculated.
!!   bonds: integer, 2D array containing the indices of the atoms that are bonded.
!!   visited: integer, 1D array containing the indices of the atoms that have already been visited.
!! Outputs:
!!   degree: integer, the degree of the given atom.
subroutine get_degree(atom, bonds, visited, degree)
    implicit none
    integer, intent(in) :: atom
    integer, intent(in), dimension(:,:) :: bonds
    integer, intent(in), dimension(:) :: visited
    integer, intent(out) :: degree

    integer :: i, trial_atom

    if (visited(atom) == 1) then
        degree = 0
        return
    end if

    degree = 0
    do i = 1, size(bonds,2)
        if (atom == bonds(1,i) .or. atom == bonds(2,i)) then
            if (atom == bonds(1,i)) then
                trial_atom = bonds(2,i)
            else
                trial_atom = bonds(1,i)
            end if

            if (visited(trial_atom) == 0) then
                degree = degree + 1
            end if
        end if
    end do

end subroutine get_degree

!> Calculates the degree of each vertex in a graph represented by a bonds.
!! Arguments:
!! bonds: integer, intent(in), dimension(:,:) :: bonds
!! visited: integer, intent(in), dimension(:) :: array of visited vertices
!! degrees: integer, intent(out), dimension(:) :: array of degrees of each vertex
subroutine get_degrees(bonds, visited, degrees)
    implicit none
    integer, intent(in), dimension(:,:) :: bonds
    integer, intent(in), dimension(:) :: visited
    integer, intent(out), dimension(:) :: degrees

    integer :: i
    degrees = 0
    do i = 1, size(visited)
        call get_degree(i, bonds, visited, degrees(i))
    end do

end subroutine get_degrees

subroutine get_lowest_degree(degrees, visited, n_degenerate_atoms, lowest_degree, success)

    implicit none
    integer, intent(in), dimension(:) :: degrees
    integer, intent(in), dimension(:) :: visited
    integer, intent(out) :: n_degenerate_atoms, lowest_degree
    logical, intent(out) :: success

    integer :: i

    lowest_degree = HUGE(1)
    n_degenerate_atoms = 0
    success = .true.

    do i = 1, size(degrees)
        if (degrees(i) < lowest_degree .and. degrees(i) /= 0 .and. visited(i) == 0) then
            lowest_degree = degrees(i)
            n_degenerate_atoms = 1
        elseif (degrees(i) == lowest_degree .and. visited(i) == 0) then
            n_degenerate_atoms = n_degenerate_atoms + 1
        end if
    end do
    if (lowest_degree > 1000) then
        !write(*,*) "lowest_degree", lowest_degree, "n_degenerate_atoms", n_degenerate_atoms
        success = .false.
        return
    end if

end subroutine get_lowest_degree

subroutine get_lowest_degree_atoms(degrees, visited, lowest_degree, lowest_degree_atoms)
    implicit none
    integer, intent(in), dimension(:) :: degrees
    integer, intent(in), dimension(:) :: visited
    integer, intent(in) :: lowest_degree
    integer, intent(out), dimension(:) :: lowest_degree_atoms
    integer :: i, idx

    idx = 1

    do i = 1, size(degrees)
        if (degrees(i) == lowest_degree .and. visited(i) == 0) then
            lowest_degree_atoms(idx) = i
            idx = idx + 1
        end if
    end do

end subroutine get_lowest_degree_atoms

subroutine get_next_edge_for_atom(atom, bonds, visited, degrees, next_edge, success)
    implicit none
    integer, intent(in) :: atom
    integer, intent(in), dimension(:, :) :: bonds
    integer, intent(in), dimension(:) :: visited
    integer, intent(in), dimension(:) :: degrees
    integer, intent(out), dimension(2) :: next_edge
    logical, intent(out) :: success

    integer :: i, n_bonds, j
    integer, dimension(:), allocatable :: trial_bonds, trial_degrees
    integer :: min_degree, next_atom

    n_bonds = 0

    next_atom = 0

    next_edge = 0
    ! Count the number of bonds for the given atom
    do i = 1, size(bonds, 2)
        if (bonds(1,i) == atom .and. visited(bonds(2, i)) == 0) then
            n_bonds = n_bonds + 1
        elseif (bonds(2,i) == atom .and. visited(bonds(1,i)) == 0) then
            n_bonds = n_bonds + 1
        end if
    end do

    if (n_bonds == 0) then
        success = .false.
        return
    else
        allocate(trial_bonds(n_bonds))
        allocate(trial_degrees(n_bonds))
    end if

    j = 1

    ! Populate trial_bonds array
    do i = 1, size(bonds, 2)
        if (bonds(1,i) == atom .and. visited(bonds(2,i)) == 0) then
            trial_bonds(j) = bonds(2,i)
            j = j + 1
        elseif (bonds(2,i) == atom .and. visited(bonds(1,i)) == 0) then
            trial_bonds(j) = bonds(1,i)
            j = j + 1
        end if
    end do

    ! Populate trial_degrees array
    do i = 1, n_bonds
        trial_degrees(i) = degrees(trial_bonds(i))
    end do

    min_degree = HUGE(1)

    ! Find the minimum degree and corresponding atom
    do i = 1, n_bonds
        if (trial_degrees(i) < min_degree) then
            min_degree = trial_degrees(i)
            next_atom = trial_bonds(i)
        end if
    end do

    ! Set the output variables
    next_edge(1) = atom
    next_edge(2) = next_atom
    success = .true.
    ! Deallocate the temporary arrays
    deallocate(trial_bonds)
    deallocate(trial_degrees)

end subroutine get_next_edge_for_atom

subroutine get_next_edges_for_atoms(atoms, bonds, visited, degrees, next_edges, final_success)
    implicit none
    integer, intent(in), dimension(:) :: atoms
    integer, intent(in), dimension(:, :) :: bonds
    integer, intent(inout), dimension(:) :: visited
    integer, intent(in), dimension(:) :: degrees
    integer, intent(out), dimension(:,:) :: next_edges
    logical, intent(out) :: final_success
    integer, dimension(:), allocatable :: updated_degrees

    integer :: i
    integer:: next_edge(2)
    logical :: success

    next_edges = 0

    final_success = .false.

    allocate(updated_degrees(size(degrees)))

    updated_degrees = degrees

    do i = 1, size(atoms)
        call get_next_edge_for_atom(atoms(i), bonds, visited, updated_degrees, next_edge, success)
        !write(*,*) "next_edge", next_edge
        if (success .and. visited(next_edge(1)) == 0 .and. visited(next_edge(2)) == 0) then
            final_success = .true.
            next_edges(:,i) = next_edge
            visited(next_edge(1)) = 1
            visited(next_edge(2)) = 1
            call get_degrees(bonds, visited, updated_degrees)
        end if
    end do

end subroutine get_next_edges_for_atoms
end module unsaturated_graph

module bond_derivatives

use fortran_helper, only : get_bij
use b_angle_derivatives, only: get_b_angle_derivatives
implicit none
public :: get_bond_derivatives, get_bond_gradient, get_bond_hessian
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_bond_derivatives(geometry, bonds, ideal_bonds, k_bonds, gradient, hessian)
    real(8), intent(in) :: geometry(:, :), ideal_bonds(:)
    integer, intent(in) ::  bonds(:, :)
    real(8), intent(in) :: k_bonds
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    integer :: n

    do n=1, size(ideal_bonds)
        call get_single_bond_derivative(geometry, bonds(:,n), ideal_bonds(n), k_bonds, gradient, hessian)
    enddo

end subroutine get_bond_derivatives

subroutine get_bond_gradient(geometry, bonds, ideal_bonds, k_bonds, gradient)
    real(8), intent(in) :: geometry(:, :), ideal_bonds(:)
    integer, intent(in) ::  bonds(:, :)
    real(8), intent(in) :: k_bonds
    real(8), intent(inout) :: gradient(:)
    integer :: n

    do n=1, size(ideal_bonds)
        call get_single_bond_gradient(geometry, bonds(:,n), ideal_bonds(n), k_bonds, gradient)
    enddo

end subroutine get_bond_gradient

subroutine get_bond_hessian(geometry, bonds, ideal_bonds, k_bonds, hessian)
    real(8), intent(in) :: geometry(:, :), ideal_bonds(:)
    integer, intent(in) ::  bonds(:, :)
    real(8), intent(in) :: k_bonds
    real(8), intent(inout) :: hessian(:,:)
    integer :: n

    do n=1, size(ideal_bonds)
        call get_single_bond_hessian(geometry, bonds(:,n), ideal_bonds(n), k_bonds, hessian)
    enddo

end subroutine get_bond_hessian

subroutine get_single_bond_gradient(geometry, bond, r0, k_bonds, gradient)
    real(8), intent(in) :: geometry(:, :), r0
    integer, intent(in) ::  bond(2)
    real(8), intent(in) :: k_bonds
    real(8), intent(inout) :: gradient(:)
    real(8) :: rij
    integer :: i,j
    integer :: xhat(6)
    real(8) :: drdx(6), d2rdxdy(21)

    i = bond(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = bond(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    call get_r_derivatives(geometry, i, j, drdx, d2rdxdy, rij)

    call build_bond_gradient(r0, rij, drdx, k_bonds, xhat, gradient)

end subroutine get_single_bond_gradient

subroutine get_single_bond_hessian(geometry, bond, r0, k_bonds, hessian)
    real(8), intent(in) :: geometry(:, :), r0
    integer, intent(in) ::  bond(2)
    real(8), intent(in) :: k_bonds
    real(8), intent(inout) :: hessian(:,:)
    real(8) :: rij
    integer :: i,j
    integer :: xhat(6)
    real(8) :: drdx(6), d2rdxdy(21)

    i = bond(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = bond(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    call get_r_derivatives(geometry, i, j, drdx, d2rdxdy, rij)

    call build_bond_hessian(r0, rij, drdx, d2rdxdy, k_bonds, xhat, hessian)

end subroutine get_single_bond_hessian

subroutine get_single_bond_derivative(geometry, bond, r0, k_bonds, gradient, hessian)
    real(8), intent(in) :: geometry(:, :), r0
    integer, intent(in) ::  bond(2)
    real(8), intent(in) :: k_bonds
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    real(8) :: rij
    integer :: i,j
    integer :: xhat(6)
    real(8) :: drdx(6), d2rdxdy(21)

    i = bond(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = bond(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    call get_r_derivatives(geometry, i, j, drdx, d2rdxdy, rij)

    call build_bond_gradient(r0, rij, drdx, k_bonds, xhat, gradient)

    call build_bond_hessian(r0, rij, drdx, d2rdxdy, k_bonds, xhat, hessian)

end subroutine get_single_bond_derivative

subroutine build_bond_gradient(r0, rij, drdx, k_bonds, xhat, gradient)

    real(8), intent(in) :: r0, rij, drdx(6), k_bonds
    integer, intent(in) :: xhat(6)
    real(8), intent(inout) :: gradient(:)
    real(8) :: g
    integer :: n

    do n=1, 6
        call get_dVbonddx(drdx(n), k_bonds, r0, rij, g)
        gradient(xhat(n)) = gradient(xhat(n)) + g
    enddo

end subroutine build_bond_gradient

subroutine build_bond_hessian(r0, rij, drdx, d2rdxdy, k_bonds, xhat, hessian)

    real(8), intent(in) :: r0, rij, drdx(6), d2rdxdy(21)
    real(8), intent(in) :: k_bonds
    integer, intent(in) :: xhat(6)
    real(8), intent(inout) :: hessian(:,:)
    real(8) :: h
    integer :: m, i, j

    do m=1, 21

        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2

        call get_d2Vbonddxdy(drdx(i), drdx(j), d2rdxdy(m), k_bonds, r0, rij, h)

        hessian(xhat(i), xhat(j)) = hessian(xhat(i), xhat(j)) + h

        if (i /= j) then

            hessian(xhat(j), xhat(i)) = hessian(xhat(j), xhat(i)) + h

        endif
    enddo

end subroutine build_bond_hessian

subroutine get_r_derivatives(geometry, i, j, drdx, d2rdxdy, rij)

    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j
    real(8), intent(out) :: drdx(6), d2rdxdy(21)
    real(8), intent(out) :: rij
    real(8) :: xij, yij, zij, dbdx(9),d2bdxdy(45)
    integer :: m

    xij = geometry(1,i) - geometry(1,j)
    yij = geometry(2,i) - geometry(2,j)
    zij = geometry(3,i) - geometry(3,j)

    call get_bij(geometry, i, j, rij)

    call get_b_angle_derivatives(xij,yij,zij,rij,dbdx,d2bdxdy)

    drdx = 0.0_wp
    do m=1, 6
        drdx(m) = dbdx(m)
    enddo

    d2rdxdy = 0.0_wp
    do m=1, 21
        d2rdxdy(m) = d2bdxdy(m)
    enddo

end subroutine get_r_derivatives


subroutine get_dVbonddx(drdx, k_bonds, r0, rij, dVbonddx)
real(8), intent(in) ::drdx, k_bonds, r0, rij
real(8), intent(out) :: dVbonddx

dVbonddx = -2*k_bonds*(r0-rij)*drdx

end subroutine get_dVbonddx

subroutine get_d2Vbonddxdy(drdx, drdy, d2rdxdy, k_bonds, r0, rij, d2Vbonddxdy)
real(8), intent(in) :: drdx, drdy, d2rdxdy, k_bonds, r0, rij
real(8), intent(out) :: d2Vbonddxdy

d2Vbonddxdy = 2*k_bonds*drdx*drdy-2*k_bonds*(r0 - rij)*d2rdxdy
end subroutine get_d2Vbonddxdy

end module bond_derivatives

module derivatives

use bond_derivatives, only: get_bond_derivatives, get_bond_gradient, get_bond_hessian
use angle_derivatives, only: get_angle_derivatives, get_angle_gradient, get_angle_hessian
use dihedral_derivatives, only: get_dihedral_derivatives, get_dihedral_gradient, get_dihedral_hessian
use repulsion_derivatives, only: get_repulsion_derivatives, get_repulsion_gradient, get_repulsion_hessian
implicit none
public :: get_derivatives
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_derivatives(n_atoms, geometry, bonds, ideal_bonds, angles, ideal_angles, &
    dihedrals, ideal_dihedrals, repulsive_partner, charges, k_bonds, k_angles, k_dihedrals, gradient, hessian)
        real(8), intent(in) :: geometry(:, :), ideal_bonds(:), ideal_angles(:), ideal_dihedrals(:), charges(:)
        integer, intent(in) ::  n_atoms, bonds(:, :), angles(:, :), dihedrals(:,:), repulsive_partner(:,:)
        real(8), intent(in) :: k_bonds, k_angles, k_dihedrals
        real(8), intent(out) :: gradient(n_atoms*3), hessian(n_atoms*3, n_atoms*3)

        gradient = 0.0_wp
        hessian = 0.0_wp

        call get_bond_derivatives(geometry, bonds, ideal_bonds, k_bonds, gradient, hessian)

        call get_angle_derivatives(geometry, angles, ideal_angles, k_angles, gradient, hessian)

        call get_dihedral_derivatives(geometry, dihedrals, ideal_dihedrals, k_dihedrals, gradient, hessian)

        call get_repulsion_derivatives(geometry, repulsive_partner, charges, gradient, hessian)

end subroutine


subroutine get_gradient(n_atoms, geometry, bonds, ideal_bonds, angles, ideal_angles, &
    dihedrals, ideal_dihedrals, repulsive_partner, charges, k_bonds, k_angles, k_dihedrals, gradient)
        real(8), intent(in) :: geometry(:, :), ideal_bonds(:), ideal_angles(:), ideal_dihedrals(:), charges(:)
        integer, intent(in) ::  n_atoms, bonds(:, :), angles(:, :), dihedrals(:,:), repulsive_partner(:,:)
        real(8), intent(in) :: k_bonds, k_angles, k_dihedrals
        real(8), intent(out) :: gradient(n_atoms*3)

        gradient = 0.0_wp

        call get_bond_gradient(geometry, bonds, ideal_bonds, k_bonds, gradient)

        call get_angle_gradient(geometry, angles, ideal_angles, k_angles, gradient)

        call get_dihedral_gradient(geometry, dihedrals, ideal_dihedrals, k_dihedrals, gradient)

        call get_repulsion_gradient(geometry, repulsive_partner, charges, gradient)

end subroutine

subroutine get_hessian(n_atoms, geometry, bonds, ideal_bonds, angles, ideal_angles, &
    dihedrals, ideal_dihedrals, repulsive_partner, charges, k_bonds, k_angles, k_dihedrals, hessian)
        real(8), intent(in) :: geometry(:, :), ideal_bonds(:), ideal_angles(:), ideal_dihedrals(:), charges(:)
        integer, intent(in) ::  n_atoms, bonds(:, :), angles(:, :), dihedrals(:,:), repulsive_partner(:,:)
        real(8), intent(in) :: k_bonds, k_angles, k_dihedrals
        real(8), intent(out) :: hessian(n_atoms*3, n_atoms*3)

        hessian = 0.0_wp

        call get_bond_hessian(geometry, bonds, ideal_bonds, k_bonds, hessian)

        call get_angle_hessian(geometry, angles, ideal_angles, k_angles, hessian)

        call get_dihedral_hessian(geometry, dihedrals, ideal_dihedrals, k_dihedrals, hessian)

        call get_repulsion_hessian(geometry, repulsive_partner, charges, hessian)

end subroutine

end module derivatives

module a_angle_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_a_angle_derivatives
integer, parameter :: wp = selected_real_kind(15)

contains

subroutine get_a_angle_derivatives(xij,yij,zij,xkj,ykj,zkj,dadx,d2adxdy)
    real(8), intent(in) :: xij,yij,zij,xkj,ykj,zkj
    real(8), intent(out) :: dadx(9), d2adxdy(45)
    real(8) :: ddx, ddy, ddz
    integer :: i

    call get_agradient(xij,yij,zij,xkj,ykj,zkj,dadx)

    call get_ahessian(xij,yij,zij,xkj,ykj,zkj,d2adxdy)
    
end subroutine get_a_angle_derivatives


subroutine get_ahessian(xij,yij,zij,xkj,ykj,zkj,d2adxdy)
    real(8), intent(in) :: xij,yij,zij,xkj,ykj,zkj
    real(8), intent(out) :: d2adxdy(45)
    real(8) :: derivative
    integer :: ij

    d2adxdy = 0.0_wp

    call gidx(1,7, ij)
    d2adxdy(ij) = 1.0_wp

    call gidx(2,8, ij)
    d2adxdy(ij) = 1.0_wp

    call gidx(3,9, ij)
    d2adxdy(ij) = 1.0_wp

    call gidx(1,4, ij)
    d2adxdy(ij) = -1.0_wp

    call gidx(2,5, ij)
    d2adxdy(ij) = -1.0_wp

    call gidx(3,6, ij)
    d2adxdy(ij) = -1.0_wp

    call gidx(4,7, ij)
    d2adxdy(ij) = -1.0_wp

    call gidx(5,8, ij)
    d2adxdy(ij) = -1.0_wp

    call gidx(6,9, ij)
    d2adxdy(ij) = -1.0_wp

    call gidx(4,4, ij)
    d2adxdy(ij) = 2.0_wp

    call gidx(5,5, ij)
    d2adxdy(ij) = 2.0_wp

    call gidx(6,6, ij)
    d2adxdy(ij) = 2.0_wp


end subroutine get_ahessian


subroutine get_agradient(xij,yij,zij,xkj,ykj,zkj,dadx)
    real(8), intent(in) :: xij,yij,zij,xkj,ykj,zkj
    real(8), intent(out) :: dadx(9)
    real(8) :: ddx, ddy, ddz

    dadx = 0.0_wp

    call get_dadxi(xkj,ddx)
    call get_dadxi(ykj,ddy)
    call get_dadxi(zkj,ddz)

    dadx(1) = ddx
    dadx(2) = ddy
    dadx(3) = ddz 
    
    call get_dadxj(xij, xkj, ddx)
    call get_dadxj(yij, ykj, ddy)
    call get_dadxj(zij, zkj, ddz)

    dadx(4) = ddx
    dadx(5) = ddy
    dadx(6) = ddz 

    call get_dadxi(xij,ddx)
    call get_dadxi(yij,ddy)
    call get_dadxi(zij,ddz)

    dadx(7) = ddx
    dadx(8) = ddy
    dadx(9) = ddz

end subroutine get_agradient


subroutine get_dadxi(xkj,derivative)
real(8), intent(in) :: xkj
real(8), intent(out) :: derivative
derivative = xkj
end subroutine get_dadxi

subroutine get_dadxj(xij, xkj, derivative)
real(8), intent(in) :: xij, xkj
real(8), intent(out) :: derivative
derivative = -xij-xkj
end subroutine get_dadxj


end module a_angle_derivatives

module angle_derivatives

use fortran_helper, only :  get_aijk, get_bij
use a_angle_derivatives, only: get_a_angle_derivatives
use b_angle_derivatives, only: get_b_angle_derivatives
use c_angle_derivatives, only: get_c_angle_derivatives
implicit none
public :: get_angle_derivatives, get_angle_gradient, get_angle_hessian
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_angle_derivatives(geometry, angles, ideal_angles, k_angles, gradient, hessian)
    real(8), intent(in) :: geometry(:, :), ideal_angles(:)
    integer, intent(in) ::  angles(:, :)
    real(8), intent(in) :: k_angles
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    integer :: n

    do n=1, size(ideal_angles)
        call get_single_angle_derivative(geometry, angles(:,n), ideal_angles(n), k_angles, gradient, hessian)
    enddo

end subroutine get_angle_derivatives


subroutine get_angle_gradient(geometry, angles, ideal_angles, k_angles, gradient)
    real(8), intent(in) :: geometry(:, :), ideal_angles(:)
    integer, intent(in) ::  angles(:, :)
    real(8), intent(in) :: k_angles
    real(8), intent(inout) :: gradient(:)
    integer :: n

    do n=1, size(ideal_angles)
        call get_single_angle_gradient(geometry, angles(:,n), ideal_angles(n), k_angles, gradient)
    enddo

end subroutine get_angle_gradient

subroutine get_angle_hessian(geometry, angles, ideal_angles, k_angles, hessian)
    real(8), intent(in) :: geometry(:, :), ideal_angles(:)
    integer, intent(in) ::  angles(:, :)
    real(8), intent(in) :: k_angles
    real(8), intent(inout) :: hessian(:,:)
    integer :: n

    do n=1, size(ideal_angles)
        call get_single_angle_hessian(geometry, angles(:,n), ideal_angles(n), k_angles, hessian)
    enddo

end subroutine get_angle_hessian

subroutine get_single_angle_derivative(geometry, angle, theta0, k_angles, gradient, hessian)
        
    real(8), intent(in) :: geometry(:, :), theta0
    integer, intent(in) ::  angle(3)
    real(8), intent(in) :: k_angles
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    real(8) :: costheta0, costheta
    integer :: i,j,k,l,m
    integer :: xhat(9)
    real(8) :: dcosdx(9), d2cosdxdy(45), aijk , bij, cjk

    i = angle(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = angle(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    k = angle(3)

    xhat(7) = 1+3*(k-1)
    xhat(8) = 2+3*(k-1)
    xhat(9)= 3+3*(k-1)

    call get_theta_derivatives(geometry, i, j, k, dcosdx, d2cosdxdy, aijk, bij, cjk)

    costheta0 = cos(theta0)

    costheta = aijk/(bij*cjk)

    call build_angle_gradient(costheta0, costheta, dcosdx, k_angles, xhat, gradient)

    call build_angle_hessian(costheta0, costheta, dcosdx, d2cosdxdy, k_angles, xhat, hessian)

end subroutine get_single_angle_derivative

subroutine get_single_angle_gradient(geometry, angle, theta0, k_angles, gradient)
        
    real(8), intent(in) :: geometry(:, :), theta0
    integer, intent(in) ::  angle(3)
    real(8), intent(in) :: k_angles
    real(8), intent(inout) :: gradient(:)
    real(8) :: costheta0, costheta
    integer :: i,j,k,l,m
    integer :: xhat(9)
    real(8) :: dcosdx(9), d2cosdxdy(45), aijk , bij, cjk

    i = angle(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = angle(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    k = angle(3)

    xhat(7) = 1+3*(k-1)
    xhat(8) = 2+3*(k-1)
    xhat(9)= 3+3*(k-1)

    call get_theta_derivatives(geometry, i, j, k, dcosdx, d2cosdxdy, aijk, bij, cjk)

    costheta0 = cos(theta0)

    costheta = aijk/(bij*cjk)

    call build_angle_gradient(costheta0, costheta, dcosdx, k_angles, xhat, gradient)

end subroutine get_single_angle_gradient

subroutine get_single_angle_hessian(geometry, angle, theta0, k_angles, hessian)
        
    real(8), intent(in) :: geometry(:, :), theta0
    integer, intent(in) ::  angle(3)
    real(8), intent(in) :: k_angles
    real(8), intent(inout) ::  hessian(:,:)
    real(8) :: costheta0, costheta
    integer :: i,j,k,l,m
    integer :: xhat(9)
    real(8) :: dcosdx(9), d2cosdxdy(45), aijk , bij, cjk

    i = angle(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = angle(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    k = angle(3)

    xhat(7) = 1+3*(k-1)
    xhat(8) = 2+3*(k-1)
    xhat(9)= 3+3*(k-1)

    call get_theta_derivatives(geometry, i, j, k, dcosdx, d2cosdxdy, aijk, bij, cjk)

    costheta0 = cos(theta0)

    costheta = aijk/(bij*cjk)

    call build_angle_hessian(costheta0, costheta, dcosdx, d2cosdxdy, k_angles, xhat, hessian)
    
end subroutine get_single_angle_hessian


subroutine build_angle_gradient(costheta0, costheta, dcosdx, k_angles, xhat, gradient)

    real(8), intent(in) :: costheta0, costheta, dcosdx(9), k_angles
    integer, intent(in) :: xhat(9)
    real(8), intent(inout) :: gradient(:)
    real(8) :: g
    integer :: n

    do n=1, 9

        call get_dVangledx(dcosdx(n), k_angles, costheta0, costheta, g)
        gradient(xhat(n)) = gradient(xhat(n)) + g

    enddo
end subroutine build_angle_gradient

subroutine build_angle_hessian(costheta0, costheta, dcosdx, d2cosdxdy, k_angles, xhat, hessian)

    real(8), intent(in) :: costheta0, costheta, dcosdx(9), d2cosdxdy(45)
    real(8), intent(in) :: k_angles
    integer, intent(in) :: xhat(9)
    real(8), intent(inout) :: hessian(:,:)
    real(8) :: h
    integer :: m, i, j

    do m=1, 45

        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2

        call get_d2Vangledxdy(dcosdx(i), dcosdx(j), d2cosdxdy(m), k_angles, costheta0, costheta, h)

        hessian(xhat(i), xhat(j)) = hessian(xhat(i), xhat(j)) + h

        if (i /= j) then

            hessian(xhat(j), xhat(i)) = hessian(xhat(j), xhat(i)) + h

        endif
    enddo

end subroutine build_angle_hessian

subroutine get_theta_derivatives(geometry, i, j, k, dcosdx, d2cosdxdy, aijk, bij, cjk)

    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k
    real(8), intent(out) :: dcosdx(9), d2cosdxdy(45)
    real(8), intent(out) :: aijk, bij, cjk
    real(8) :: dadx(9),dbdx(9),dcdx(9)
    real(8) :: d2adxdy(45), d2bdxdy(45), d2cdxdy(45)
    real(8) :: xij, yij, zij, xkj, ykj, zkj
    integer :: m

    xij = geometry(1,i) - geometry(1,j)
    yij = geometry(2,i) - geometry(2,j)
    zij = geometry(3,i) - geometry(3,j)

    xkj = geometry(1,k) - geometry(1,j)
    ykj = geometry(2,k) - geometry(2,j)
    zkj = geometry(3,k) - geometry(3,j)

    call get_aijk(geometry, i, j, k, aijk)
    call get_bij(geometry, i, j, bij)
    call get_bij(geometry, j, k, cjk)

    call get_a_angle_derivatives(xij,yij,zij,xkj,ykj,zkj,dadx,d2adxdy)

    call get_b_angle_derivatives(xij,yij,zij,bij,dbdx,d2bdxdy)

    call get_c_angle_derivatives(xkj,ykj,zkj,cjk, dcdx, d2cdxdy)

    call get_theta_gradient(aijk, bij, cjk, dadx, dbdx, dcdx, dcosdx)

    call get_theta_hessian(aijk, bij, cjk, dadx, dbdx, dcdx, &
                            d2adxdy, d2bdxdy, d2cdxdy, d2cosdxdy)

end subroutine get_theta_derivatives

subroutine get_theta_gradient(aijk, bij, cjk, dadx, dbdx, dcdx, dcosdx)

    real(8), intent(in) :: aijk, bij, cjk, dadx(9), dbdx(9), dcdx(9)
    real(8) :: cosx
    real(8), intent(out) :: dcosdx(9)
    integer :: m
    
    dcosdx = 0.0_wp

    do m=1, 9

        if (m < 4) then

        call get_ddxi(aijk, bij, cjk, dadx(m), dbdx(m), cosx)
        dcosdx(m) = cosx

        else if (m > 6) then
        call get_ddxi(aijk, cjk, bij, dadx(m), dcdx(m), cosx)
        dcosdx(m) = cosx

        else
        call get_ddxj(aijk, bij, cjk, dadx(m), dbdx(m), dcdx(m), cosx)
        dcosdx(m) = cosx
        
        endif

    enddo

end subroutine get_theta_gradient

subroutine get_theta_hessian(aijk, bij, cjk, dadx, dbdx, dcdx, d2adxdy, d2bdxdy, d2cdxdy, d2cosdxdy)
  
    real(8), intent(in) :: aijk, bij, cjk, dadx(9), dbdx(9), dcdx(9) 
    real(8), intent(in) :: d2adxdy(45), d2bdxdy(45), d2cdxdy(45)
    real(8), intent(out) :: d2cosdxdy(45)
    real(8) :: cosxy
    integer :: m, i, j
   
    do m=1, 45

        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2

        call get_d2dxdy(aijk, bij, cjk, dadx(i), dadx(j), d2adxdy(m), dbdx(i), dbdx(j), d2bdxdy(m), &
                         dcdx(i), dcdx(j), d2cdxdy(m), cosxy)

        d2cosdxdy(m) = cosxy  
    enddo

end subroutine get_theta_hessian

subroutine get_d2dxdy(aijk, bij, cjk, dadx, dady, d2adxdy, dbdx, dbdy, d2bdxdy, dcdx, dcdy, d2cdxdy, d2dxdy)

    real(8), intent(in) :: aijk, bij, cjk, dadx, dady, d2adxdy, dbdx, dbdy, d2bdxdy, dcdx, dcdy, d2cdxdy
    real(8), intent(out) :: d2dxdy
    real(8) :: term1, term2, term3, term4, term5, term6, term7, term8, term9, term10, term11

    term1 = aijk*d2cdxdy/cjk
    term2 = 2*aijk*dcdx*dcdy/(cjk**2)
    term3 = aijk*d2bdxdy/bij
    term4 = aijk*dbdx*dcdy/(bij*cjk)
    term5 = aijk*dbdy*dcdx/(bij*cjk)
    term6 = 2*aijk*dbdx*dbdy/(bij**2)
    term7 = d2adxdy
    term8 = dadx*dcdy/cjk
    term9 = dady*dcdx/cjk
    term10 = dadx*dbdy/bij
    term11 = dady*dbdx/bij
    d2dxdy = (-term1+term2-term3+term4+term5+term6+term7-term8-term9-term10-term11)/(bij*cjk)

end subroutine get_d2dxdy

subroutine get_dVangledx(dcosdx, k_angles, costheta0, costheta, dVangledx)

real(8), intent(in) :: dcosdx, k_angles, costheta0, costheta
real(8), intent(out) :: dVangledx

dVangledx = -2*k_angles*(dacos(costheta0)-dacos(costheta))*(-dcosdx/(sqrt(1-costheta**2)))

end subroutine get_dVangledx

subroutine get_d2Vangledxdy(dcosdx, dcosdy, d2cosdxdy, k_angles, costheta0, costheta, d2Vangledxdy)
real(8), intent(in) :: dcosdx, dcosdy, d2cosdxdy, k_angles, costheta0, costheta
real(8), intent(out) :: d2Vangledxdy
real(8) :: dthetadcos, d2thetadcos2

dthetadcos = -1/sqrt(1-costheta**2)

d2thetadcos2 = - costheta/sqrt(1-costheta**2)**1.5_wp

d2Vangledxdy = 2*k_angles*(-(dacos(costheta0)-dacos(costheta))*dthetadcos*d2cosdxdy &
            -(dacos(costheta0)-dacos(costheta))*d2thetadcos2*dcosdx*dcosdy+dthetadcos**2*dcosdx*dcosdy)

end subroutine get_d2Vangledxdy

subroutine get_ddxi(aijk, bij, cjk, dadxi, dbdxi, ddxi)

    real(8), intent(in) :: aijk, bij, cjk, dadxi, dbdxi
    real(8), intent(out) :: ddxi

    ddxi = - (aijk*dbdxi)/(bij**2*cjk) + dadxi/(bij*cjk)

end subroutine get_ddxi

subroutine get_ddxj(aijk, bij, cjk, dadxj, dbdxj, dcdxj, ddxj)

    real(8), intent(in) :: aijk, cjk, bij, dadxj, dbdxj,dcdxj
    real(8), intent(out) :: ddxj

    ddxj = - (aijk*dcdxj)/(bij*cjk**2)-(aijk*dbdxj)/(bij**2*cjk)+dadxj/(bij*cjk)

end subroutine get_ddxj

end module angle_derivatives

module unsaturated_edges
implicit none
public :: get_unsaturated_atoms, get_unsaturated_bond_matrix, get_unsaturated_bonds
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_unsaturated_atoms(n_atoms, valences, current_valences, unsaturated_atoms, degree_unsaturation)
    integer :: n_atoms
    integer, intent(in) :: valences(:)
    integer, intent(in) :: current_valences(:)
    integer :: i, j, k, l, atomic_valence, current_valence
    integer, intent(out) :: unsaturated_atoms(n_atoms), degree_unsaturation(n_atoms)

    unsaturated_atoms = 0
    degree_unsaturation = 0

    do i=1, n_atoms

        atomic_valence = valences(i)

        current_valence = current_valences(i)

        if (atomic_valence > current_valence) then
                unsaturated_atoms(i) = 1
                degree_unsaturation(i) = atomic_valence - current_valence
        endif
    enddo

end subroutine get_unsaturated_atoms

subroutine get_unsaturated_bond_matrix(n_atoms, cn_matrix, unsaturated_atoms, unsaturated_bond_matrix, n_bonds)
    integer :: n_atoms
    integer, intent(in) :: cn_matrix(:,:)
    integer, intent(in) :: unsaturated_atoms(:)
    integer :: i, j, k, l
    integer, intent(out):: unsaturated_bond_matrix(n_atoms,n_atoms)
    integer, intent(out):: n_bonds

    unsaturated_bond_matrix = 0
    n_bonds = 0
    do i=1, n_atoms
        do j=1, n_atoms
            if (j > i .and. cn_matrix(i,j) > 0 .and. unsaturated_atoms(i) == 1 .and. unsaturated_atoms(j) == 1) then
                n_bonds = n_bonds + 1
                unsaturated_bond_matrix(i,j) = 1
                unsaturated_bond_matrix(j,i) = 1
            endif
        enddo
    enddo

end subroutine get_unsaturated_bond_matrix

subroutine get_unsaturated_bonds(unsaturated_bond_matrix, unsaturated_bonds)
    integer, intent(in) :: unsaturated_bond_matrix(:,:)
    integer, intent(out) :: unsaturated_bonds(:,:)
    integer :: i, j, k, l, counter
    unsaturated_bonds = 0
    k = 1
    do i=1, size(unsaturated_bond_matrix, dim=1)
        do j=1, size(unsaturated_bond_matrix, dim=2)
            if (j > i .and. unsaturated_bond_matrix(i,j) > 0) then
                unsaturated_bonds(1,k) = i 
                unsaturated_bonds(2,k) = j
                k = k + 1
            endif
        enddo
    enddo
end subroutine get_unsaturated_bonds

end module unsaturated_edges

module b_dihedral_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_b_dihedral_derivatives
integer, parameter :: wp = selected_real_kind(15)
contains


subroutine get_b_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, bijk, dbdx,d2bdxdy)
    real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,bijk
    real(8), intent(out) :: dbdx(12),d2bdxdy(78)
    real(8) :: ddx, ddy, ddz

    call get_bgradient(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, bijk, dbdx)
    call get_bhessian(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,d2bdxdy)

end subroutine get_b_dihedral_derivatives


subroutine get_bhessian(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,d2bdxdy)
    real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk
    real(8), intent(out) :: d2bdxdy(78)
    real(8) :: derivative
    integer :: ij

    d2bdxdy = 0.0_wp

    ! i i
    call get_d2bdxidxi(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(1, 1, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(2, 2, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(3, 3, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(1, 2, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(xji, zji, yji, xkj, zkj, ykj, derivative)
    call gidx(1, 3, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(2, 3, ij)
    d2bdxdy(ij) = derivative

    !i j
    call get_d2bdxidxj(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(1, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxj(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(2, 5, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxj(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(3, 6, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(1, 5, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(xji, zji, yji, xkj, zkj, ykj, derivative)
    call gidx(1, 6, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(2, 6, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(yji, xji, zji, ykj, xkj, zkj, derivative)
    call gidx(2, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(3, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(zji, yji, xji, zkj, ykj, xkj, derivative)
    call gidx(3, 5, ij)
    d2bdxdy(ij) = derivative

    !j j
    call get_d2bdxjdxj(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(4, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdxj(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(5, 5, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdxj(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(6, 6, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyj(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(4, 5, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyj(xji, zji, yji, xkj, zkj, ykj, derivative)
    call gidx(4, 6, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyj(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(5, 6, ij)
    d2bdxdy(ij) = derivative

    ! i k 

    call get_d2bdxidxk(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(1, 7, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxk(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(2, 8, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxk(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(3, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyk(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(1, 8, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyk(xji, zji, yji, xkj, zkj, ykj, derivative)
    call gidx(1, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyk(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(2, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyk(yji, xji, zji, ykj, xkj, zkj, derivative)
    call gidx(2, 7, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyk(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(3, 7, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyk(zji, yji, xji, zkj, ykj, xkj, derivative)
    call gidx(3, 8, ij)
    d2bdxdy(ij) = derivative

    ! j k
    call get_d2bdxjdxk(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(4, 7, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdxk(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(5, 8, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdxk(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(6, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyk(xji, yji, zji, xkj, ykj, zkj, derivative)
    call gidx(4, 8, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyk(xji, zji, yji, xkj, zkj, ykj, derivative)
    call gidx(4, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyk(yji, zji, xji, ykj, zkj, xkj, derivative)
    call gidx(5, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyk(yji, xji, zji, ykj, xkj, zkj, derivative)
    call gidx(5, 7, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyk(zji, xji, yji, zkj, xkj, ykj, derivative)
    call gidx(6, 7, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxjdyk(zji, yji, xji, zkj, ykj, xkj, derivative)
    call gidx(6, 8, ij)
    d2bdxdy(ij) = derivative

    ! k k 

    call get_d2bdxidxi(xkj, ykj, zkj,xji, yji, zji,  derivative)
    call gidx(7, 7, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(ykj, zkj, xkj, yji, zji, xji, derivative)
    call gidx(8, 8, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(zkj, xkj, ykj,zji, xji, yji,  derivative)
    call gidx(9, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(xkj, ykj, zkj,xji, yji, zji,  derivative)
    call gidx(7, 8, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(xkj, zkj, ykj, xji, zji, yji,  derivative)
    call gidx(7, 9, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(ykj, zkj, xkj, yji, zji, xji,  derivative)
    call gidx(8, 9, ij)
    d2bdxdy(ij) = derivative

end subroutine get_bhessian


subroutine get_d2bdxidxi(xji, yji, zji, xkj, ykj, zkj, derivative)

real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = ((ykj**2 + zkj**2)*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 &
                + (yji*zkj - ykj*zji)**2) - (ykj*(xji*ykj - xkj*yji) + zkj*(xji*zkj - xkj*zji))**2)
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)

derivative = enumerator/denominator
end subroutine get_d2bdxidxi

subroutine get_d2bdxidyi(xji, yji, zji, xkj, ykj, zkj, derivative)

real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = - xkj*ykj*((xji*ykj - xkj*yji)**2 + (xji * zkj - xkj * zji)**2 + (yji * zkj - ykj * zji)**2) &
                + (xkj* (xji * ykj - xkj * yji) - zkj * (yji * zkj - ykj * zji))*(ykj*(xji*ykj - xkj*yji) &
                + zkj*(xji*zkj - xkj*zji))
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)

derivative = enumerator/denominator
end subroutine get_d2bdxidyi

subroutine get_d2bdxjdxj(xji, yji, zji, xkj, ykj, zkj, derivative)

real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = - ((yji + ykj)*(xji*ykj - xkj*yji) + (zji + zkj)*(xji*zkj - xkj*zji))**2 + ((yji + ykj)**2 &
                + (zji + zkj)**2)*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)

denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)

derivative = enumerator/denominator
end subroutine get_d2bdxjdxj


subroutine get_d2bdxjdyj(xji, yji, zji, xkj, ykj, zkj, derivative)

real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = - (xji + xkj)*(yji + ykj)*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2) &
            + (- (xji + xkj)*(xji*ykj - xkj*yji) + (zji + zkj)*(yji*zkj - ykj*zji))*(- (yji + ykj)*(xji*ykj - xkj*yji) &
            - (zji + zkj)*(xji*zkj - xkj*zji))
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)

derivative = enumerator/denominator
end subroutine get_d2bdxjdyj

subroutine get_d2bdxidxj(xji, yji, zji, xkj, ykj, zkj, derivative)

real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = - (ykj*(yji + ykj) + zkj*(zji + zkj))*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2) &
                + (ykj*(xji*ykj - xkj*yji) + zkj*(xji*zkj - xkj*zji))*((yji + ykj)*(xji*ykj - xkj*yji) + &
                 (zji + zkj)*(xji*zkj - xkj*zji))
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)

derivative = enumerator/denominator
end subroutine get_d2bdxidxj

subroutine get_d2bdxidyj(xji, yji, zji, xkj, ykj, zkj, derivative)

real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = (ykj*(xji*ykj - xkj*yji) + zkj*(xji*zkj - xkj*zji))*(- (xji + xkj)*(xji*ykj - xkj*yji) + &
             (zji + zkj)*(yji*zkj - ykj*zji)) - (- xji*ykj + xkj*yji - ykj*(xji + xkj))*((xji*ykj - xkj*yji)**2 &
              + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)
derivative = enumerator/denominator
end subroutine get_d2bdxidyj

subroutine get_d2bdxidxk(xji, yji, zji, xkj, ykj, zkj, derivative)
real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = (yji*ykj + zji*zkj)*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2) &
            - (yji*(xji*ykj - xkj*yji) + zji*(xji*zkj - xkj*zji))*(ykj*(xji*ykj - xkj*yji) + zkj*(xji*zkj - xkj*zji))
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)
derivative = enumerator/denominator
end subroutine get_d2bdxidxk

subroutine get_d2bdxidyk(xji, yji, zji, xkj, ykj, zkj, derivative)
real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = (- 2*xji*ykj + xkj*yji)*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2) &
            + (xji*(xji*ykj - xkj*yji) - zji*(yji*zkj - ykj*zji))*(ykj*(xji*ykj - xkj*yji) + zkj*(xji*zkj - xkj*zji))
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)
derivative = enumerator/denominator
end subroutine get_d2bdxidyk

subroutine get_d2bdxjdxk(xji, yji, zji, xkj, ykj, zkj, derivative)
real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = - (yji*(yji + ykj) + zji*(zji + zkj))*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 & 
            + (yji*zkj - ykj*zji)**2) + (yji*(xji*ykj - xkj*yji) + zji*(xji*zkj - xkj*zji))*((yji + ykj)*(xji*ykj - xkj*yji) &
            + (zji + zkj)*(xji*zkj - xkj*zji))
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)
derivative = enumerator/denominator
end subroutine get_d2bdxjdxk

subroutine get_d2bdxjdyk(xji, yji, zji, xkj, ykj, zkj, derivative)
real(8), intent(in) :: xji, yji, zji, xkj, ykj, zkj
real(8), intent(out) :: derivative
real(8) :: enumerator, denominator
enumerator = (xji*(xji*ykj - xkj*yji) - zji*(yji*zkj - ykj*zji))*(- (yji + ykj)*(xji*ykj - xkj*yji) - &
            (zji + zkj)*(xji*zkj - xkj*zji)) - (- xji*ykj - xji*(yji + ykj) &
            + xkj*yji)*((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)
denominator = (((xji*ykj - xkj*yji)**2 + (xji*zkj - xkj*zji)**2 + (yji*zkj - ykj*zji)**2)**1.5_wp)
derivative = enumerator/denominator
end subroutine get_d2bdxjdyk


subroutine get_bgradient(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, bijk, dbdx)
    real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,bijk
    real(8), intent(out) :: dbdx(12)
    real(8) :: ddx, ddy, ddz

    dbdx = 0.0_wp

    call get_dbdxi(xji,yji,zji,xkj,ykj,zkj,bijk,ddx)
    call get_dbdxi(yji,zji,xji,ykj,zkj,xkj,bijk,ddy)
    call get_dbdxi(zji,xji,yji,zkj,xkj,ykj,bijk,ddz)

    dbdx(1) = ddx
    dbdx(2) = ddy
    dbdx(3) = ddz 


    call get_dbdxj(xji,yji,zji,xkj,ykj,zkj,bijk,ddx)
    call get_dbdxj(yji,zji,xji,ykj,zkj,xkj,bijk,ddy)
    call get_dbdxj(zji,xji,yji,zkj,xkj,ykj,bijk,ddz)

    dbdx(4) = ddx
    dbdx(5) = ddy
    dbdx(6) = ddz 

    call get_dbdxk(xji, yji, zji, xkj, ykj, zkj, bijk, ddx)
    call get_dbdxk(yji, zji, xji, ykj, zkj, xkj, bijk, ddy)
    call get_dbdxk(zji, xji, yji, zkj, xkj, ykj,bijk, ddz)

    dbdx(7) = ddx
    dbdx(8) = ddy
    dbdx(9) = ddz

end subroutine get_bgradient


subroutine get_dbdxi(xji,yji,zji,xkj,ykj,zkj,bijk,derivative)
    real(8), intent(in) :: xji,yji,xkj,ykj,zkj,zji,bijk
    real(8), intent(out) :: derivative
    real(8) :: numerator, denominator
    numerator = ykj*(xji*ykj - xkj*yji) - zkj*(-xji*zkj + xkj*zji)
    denominator = bijk
    derivative = -numerator / denominator
end subroutine get_dbdxi

subroutine get_dbdxj(xji,yji,zji,xkj,ykj,zkj,bijk,derivative)
    real(8), intent(in) :: xji,yji,xkj,ykj,zkj,zji,bijk
    real(8), intent(out) :: derivative
    real(8) :: num1, num2, den
    num1 = yji*(xji*ykj - xkj*yji) - zji*(-xji*zkj + xkj*zji)
    num2 = ykj*(xji*ykj - xkj*yji) - zkj*(-xji*zkj + xkj*zji)
    den = bijk
    derivative = (num1 + num2) / den
end subroutine get_dbdxj

subroutine get_dbdxk(xji, yji, zji, xkj, ykj, zkj, bijk, derivative)
    real(8), intent(in) :: xji, yji, xkj, ykj, zkj, zji, bijk
    real(8), intent(out) :: derivative
    derivative = (-yji*(xji*ykj - xkj*yji) - zji*(xji*zkj - xkj*zji)) / bijk
end subroutine get_dbdxk

end module b_dihedral_derivatives

module c_dihedral_derivatives
use b_dihedral_derivatives, only: get_b_dihedral_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_c_dihedral_derivatives
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_c_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, cjkl, & 
                                dcdx, d2cdxdy)
    intrinsic :: floor, sqrt
    real(8), intent(in) :: xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,cjkl
    real(8), intent(out) :: dcdx(12), d2cdxdy(78)
    real(8) :: ddx, ddy, ddz, dbdx(12), d2bdxdy(78)
    integer :: n, m, i, j, ij

    dcdx = 0.0_wp
    d2cdxdy = 0.0_wp

    call get_b_dihedral_derivatives(xkj,ykj,zkj,xlk,ylk,zlk,xji,yji,zji, cjkl,& 
                                dbdx, d2bdxdy)
    
    do m = 1, 9
        dcdx(m+3) = dbdx(m)
    enddo

    do m = 1, 45
        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2
        i = i + 3
        j = j + 3
        call gidx(i, j, ij)
        d2cdxdy(ij) = d2bdxdy(m)
    enddo

end subroutine get_c_dihedral_derivatives

end module c_dihedral_derivatives

module c_angle_derivatives
use b_angle_derivatives, only: get_b_angle_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_c_angle_derivatives
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_c_angle_derivatives(xkj,ykj,zkj,cjk, dcdx, d2cdxdy)
    intrinsic :: floor, sqrt
    real(8), intent(in) :: xkj,ykj,zkj,cjk
    real(8), intent(out) :: dcdx(9), d2cdxdy(45)
    real(8) :: dbdx(9), d2bdxdy(45)
    integer :: n, m, i, j, ij

    dcdx = 0.0_wp
    d2cdxdy = 0.0_wp

    call get_b_angle_derivatives(xkj,ykj,zkj,cjk,dbdx,d2bdxdy)
    
    do m = 1, 3
        dcdx(m+6) = dbdx(m)
    enddo
    do m = 4, 6
        dcdx(m) = dbdx(m)
    enddo

    do m = 1, 21
        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2

        if (i < 4) then
            i = i + 6
        endif
        if (j < 4) then
            j = j + 6
        endif
        call gidx(i, j, ij)
        d2cdxdy(ij) = d2bdxdy(m)
    enddo

end subroutine get_c_angle_derivatives

end module c_angle_derivatives

module dihedral_derivatives
   
use fortran_helper, only :  get_aijkl, get_bijk, get_cjkl, get_dijkl
use a_dihedral_derivatives, only: get_a_dihedral_derivatives
use b_dihedral_derivatives, only: get_b_dihedral_derivatives
use c_dihedral_derivatives, only: get_c_dihedral_derivatives
use d_dihedral_derivatives, only: get_d_dihedral_derivatives
implicit none
public :: get_dihedral_derivatives, get_dihedral_gradient, get_dihedral_hessian
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_dihedral_derivatives(geometry, dihedrals, ideal_dihedrals, k_dihedrals, gradient, hessian)
    real(8), intent(in) :: geometry(:, :), ideal_dihedrals(:)
    integer, intent(in) ::  dihedrals(:, :)
    real(8), intent(in) :: k_dihedrals
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    integer :: n

    do n=1, size(ideal_dihedrals)

        call get_single_dihedral_derivative(geometry, dihedrals(:,n), ideal_dihedrals(n), k_dihedrals, gradient, hessian)
        
    enddo
end subroutine get_dihedral_derivatives

subroutine get_dihedral_gradient(geometry, dihedrals, ideal_dihedrals, k_dihedrals, gradient)
    real(8), intent(in) :: geometry(:, :), ideal_dihedrals(:)
    integer, intent(in) ::  dihedrals(:, :)
    real(8), intent(in) :: k_dihedrals
    real(8), intent(inout) :: gradient(:)
    integer :: n

    do n=1, size(ideal_dihedrals)

        call get_single_dihedral_gradient(geometry, dihedrals(:,n), ideal_dihedrals(n), k_dihedrals, gradient)
        
    enddo
end subroutine get_dihedral_gradient


subroutine get_dihedral_hessian(geometry, dihedrals, ideal_dihedrals, k_dihedrals, hessian)
    real(8), intent(in) :: geometry(:, :), ideal_dihedrals(:)
    integer, intent(in) ::  dihedrals(:, :)
    real(8), intent(in) :: k_dihedrals
    real(8), intent(inout) :: hessian(:,:)
    integer :: n

    do n=1, size(ideal_dihedrals)

        call get_single_dihedral_hessian(geometry, dihedrals(:,n), ideal_dihedrals(n), k_dihedrals, hessian)
        
    enddo
end subroutine get_dihedral_hessian


subroutine get_single_dihedral_derivative(geometry, dihedral, phi0, k_dihedrals, gradient, hessian)
        
    real(8), intent(in) :: geometry(:, :), phi0
    integer, intent(in) ::  dihedral(4)
    real(8), intent(in) :: k_dihedrals
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    real(8) :: cosphi0, sinphi0, cosphi, sinphi
    integer :: i,j,k,l, x_hat_i, y_hat_i, z_hat_i, x_hat_j, y_hat_j, z_hat_j
    integer :: xhat(12)
    real(8) :: gxi, gyi, gzi, gxj, gyj, gzj, gxk, gyk, gzk, gxl, gyl, gzl
    real(8) :: dcosdx(12), dsindx(12), d2cosdxdy(78), d2sindxdy(78), aijkl, bijk, cjkl, dijkl
    integer :: m

    i = dihedral(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = dihedral(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    k = dihedral(3)

    xhat(7) = 1+3*(k-1)
    xhat(8) = 2+3*(k-1)
    xhat(9)= 3+3*(k-1)

    l = dihedral(4)

    xhat(10) = 1+3*(l-1)
    xhat(11) = 2+3*(l-1)
    xhat(12) = 3+3*(l-1)

    call get_phi_derivatives(geometry, i, j, k, l, dcosdx, d2cosdxdy,dsindx, d2sindxdy, aijkl, bijk, cjkl, dijkl)

    cosphi0 = cos(phi0)
    sinphi0 = sin(phi0)
    cosphi = aijkl/(bijk*cjkl)
    sinphi = dijkl/(bijk*cjkl)


    call build_dihedral_gradient(phi0, cosphi0,sinphi0,sinphi, cosphi, dcosdx, dsindx,k_dihedrals,xhat, gradient)

    call build_dihedral_hessian(phi0, cosphi0,sinphi0,sinphi, cosphi, dcosdx, d2cosdxdy, &
                                 dsindx, d2sindxdy, k_dihedrals, xhat, hessian)


end subroutine get_single_dihedral_derivative

subroutine get_single_dihedral_gradient(geometry, dihedral, phi0, k_dihedrals, gradient)
        
    real(8), intent(in) :: geometry(:, :), phi0
    integer, intent(in) ::  dihedral(4)
    real(8), intent(in) :: k_dihedrals
    real(8), intent(inout) :: gradient(:)
    real(8) :: cosphi0, sinphi0, cosphi, sinphi
    integer :: i,j,k,l, x_hat_i, y_hat_i, z_hat_i, x_hat_j, y_hat_j, z_hat_j
    integer :: xhat(12)
    real(8) :: gxi, gyi, gzi, gxj, gyj, gzj, gxk, gyk, gzk, gxl, gyl, gzl
    real(8) :: dcosdx(12), dsindx(12), d2cosdxdy(78), d2sindxdy(78), aijkl, bijk, cjkl, dijkl
    integer :: m

    i = dihedral(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = dihedral(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    k = dihedral(3)

    xhat(7) = 1+3*(k-1)
    xhat(8) = 2+3*(k-1)
    xhat(9)= 3+3*(k-1)

    l = dihedral(4)

    xhat(10) = 1+3*(l-1)
    xhat(11) = 2+3*(l-1)
    xhat(12) = 3+3*(l-1)

    call get_phi_derivatives(geometry, i, j, k, l, dcosdx, d2cosdxdy,dsindx, d2sindxdy, aijkl, bijk, cjkl, dijkl)

    cosphi0 = cos(phi0)
    sinphi0 = sin(phi0)
    cosphi = aijkl/(bijk*cjkl)
    sinphi = dijkl/(bijk*cjkl)

    call build_dihedral_gradient(phi0, cosphi0,sinphi0,sinphi, cosphi, dcosdx, dsindx,k_dihedrals,xhat, gradient)

end subroutine get_single_dihedral_gradient

subroutine get_single_dihedral_hessian(geometry, dihedral, phi0, k_dihedrals, hessian)
        
    real(8), intent(in) :: geometry(:, :), phi0
    integer, intent(in) ::  dihedral(4)
    real(8), intent(in) :: k_dihedrals
    real(8), intent(inout) :: hessian(:,:)
    real(8) :: cosphi0, sinphi0, cosphi, sinphi
    integer :: i,j,k,l, x_hat_i, y_hat_i, z_hat_i, x_hat_j, y_hat_j, z_hat_j
    integer :: xhat(12)
    real(8) :: gxi, gyi, gzi, gxj, gyj, gzj, gxk, gyk, gzk, gxl, gyl, gzl
    real(8) :: dcosdx(12), dsindx(12), d2cosdxdy(78), d2sindxdy(78), aijkl, bijk, cjkl, dijkl
    integer :: m

    i = dihedral(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = dihedral(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    k = dihedral(3)

    xhat(7) = 1+3*(k-1)
    xhat(8) = 2+3*(k-1)
    xhat(9)= 3+3*(k-1)

    l = dihedral(4)

    xhat(10) = 1+3*(l-1)
    xhat(11) = 2+3*(l-1)
    xhat(12) = 3+3*(l-1)

    call get_phi_derivatives(geometry, i, j, k, l, dcosdx, d2cosdxdy,dsindx, d2sindxdy, aijkl, bijk, cjkl, dijkl)

    cosphi0 = cos(phi0)
    sinphi0 = sin(phi0)
    cosphi = aijkl/(bijk*cjkl)
    sinphi = dijkl/(bijk*cjkl)

    call build_dihedral_hessian(phi0, cosphi0,sinphi0,sinphi, cosphi, dcosdx, d2cosdxdy, &
                                 dsindx, d2sindxdy, k_dihedrals, xhat, hessian)


end subroutine get_single_dihedral_hessian

subroutine build_dihedral_gradient(phi0, cosphi0,sinphi0,sinphi, cosphi,dcosdx, dsindx, k_dihedrals,xhat, gradient)

    real(8), intent(in) :: phi0, cosphi0, sinphi0, sinphi, cosphi, dcosdx(12), dsindx(12), k_dihedrals
    integer, intent(in) :: xhat(12)
    real(8), intent(inout) :: gradient(:)
    real(8) :: g
    integer :: n

    do n=1, 12

        call get_dVdihedraldx(dcosdx(n), dsindx(n), k_dihedrals, cosphi0, sinphi0, cosphi, sinphi, g)
        gradient(xhat(n)) = gradient(xhat(n)) + g

    enddo
end subroutine build_dihedral_gradient

subroutine build_dihedral_hessian(phi0, cosphi0,sinphi0,sinphi, cosphi, dcosdx, d2cosdxdy, dsindx, d2sindxdy, k_dihedrals, xhat, & 
                                hessian)

    real(8), intent(in) :: phi0, cosphi0,sinphi0,sinphi, cosphi, dcosdx(12),d2cosdxdy(78), dsindx(12), d2sindxdy(78)
    real(8), intent(in) :: k_dihedrals
    integer, intent(in) :: xhat(12)
    real(8), intent(inout) :: hessian(:,:)
    real(8) :: h
    integer :: m, i, j

    do m=1, 78

        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2

        call get_d2Vdihedraldxdy(dcosdx(i), dcosdx(j), d2cosdxdy(m), dsindx(i), dsindx(j), d2sindxdy(m), k_dihedrals, &
                                cosphi0, sinphi0, cosphi, sinphi, h)

        hessian(xhat(i), xhat(j)) = hessian(xhat(i), xhat(j)) + h

        if (i /= j) then

            hessian(xhat(j), xhat(i)) = hessian(xhat(j), xhat(i)) + h

        endif
    enddo

end subroutine build_dihedral_hessian

subroutine get_phi_derivatives(geometry, i, j, k, l, dcosdx, d2cosdxdy, dsindx, d2sindxdy, aijkl, bijk, cjkl, dijkl)

    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j, k, l
    real(8), intent(out) :: dcosdx(12), d2cosdxdy(78), dsindx(12), d2sindxdy(78)
    real(8), intent(out) :: aijkl, bijk, cjkl, dijkl
    real(8) :: dadx(12),dbdx(12),dcdx(12),dddx(12)
    real(8) :: d2adxdy(78),d2bdxdy(78),d2cdxdy(78), d2ddxdy(78)
    real(8) :: xji, yji, zji, xkj, ykj, zkj, xlk, ylk, zlk
    integer :: m

    dadx = 0.0_wp
    dbdx = 0.0_wp
    dcdx = 0.0_wp
    dddx = 0.0_wp

    d2adxdy = 0.0_wp
    d2bdxdy = 0.0_wp
    d2cdxdy = 0.0_wp
    d2ddxdy = 0.0_wp

    xji = geometry(1,j) - geometry(1,i)
    yji = geometry(2,j) - geometry(2,i)
    zji = geometry(3,j) - geometry(3,i)

    xkj = geometry(1,k) - geometry(1,j)
    ykj = geometry(2,k) - geometry(2,j)
    zkj = geometry(3,k) - geometry(3,j)

    xlk = geometry(1,l) - geometry(1,k)
    ylk = geometry(2,l) - geometry(2,k)
    zlk = geometry(3,l) - geometry(3,k)


    call get_aijkl(geometry, i, j, k, l, aijkl)
    call get_bijk(geometry, i, j, k, bijk)
    call get_cjkl(geometry, j, k, l, cjkl)
    call get_dijkl(geometry, i, j, k, l, dijkl)

    call get_a_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,& 
                                dadx, d2adxdy)

    call get_b_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, bijk,& 
                                dbdx, d2bdxdy)

    call get_c_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk, cjkl,& 
                                dcdx, d2cdxdy)

    call get_d_dihedral_derivatives(xji,yji,zji,xkj,ykj,zkj,xlk,ylk,zlk,& 
                                dddx, d2ddxdy)

    call get_phi_gradient(aijkl, bijk, cjkl, dijkl, dadx, dbdx, dcdx, dddx, dcosdx, dsindx)

    call get_phi_hessian(aijkl, bijk, cjkl, dijkl, dadx, dbdx, dcdx, dddx, &
                            d2adxdy, d2bdxdy, d2cdxdy, d2ddxdy, d2cosdxdy, d2sindxdy)


end subroutine get_phi_derivatives

subroutine get_phi_gradient(aijkl, bijk, cjkl, dijkl, dadx, dbdx, dcdx, dddx, dcosdx, dsindx)

    real(8), intent(in) :: aijkl, bijk, cjkl, dijkl, dadx(12), dbdx(12), dcdx(12), dddx(12)
    real(8) :: cosx, sinx
    real(8), intent(out) :: dcosdx(12), dsindx(12)
    integer :: m
    
    do m=1, 12

        if (m < 4) then

        call get_ddxi(aijkl, bijk, cjkl, dadx(m), dbdx(m), cosx)
        call get_ddxi(dijkl, bijk, cjkl, dddx(m), dbdx(m), sinx)
        dcosdx(m) = cosx
        dsindx(m) = sinx

        else if (m > 9) then
        call get_ddxi(aijkl, cjkl, bijk, dadx(m), dcdx(m), cosx)
        call get_ddxi(dijkl, cjkl, bijk, dddx(m), dcdx(m), sinx)
        dcosdx(m) = cosx
        dsindx(m) = sinx

        else

        call get_ddxj(aijkl, bijk, cjkl, dadx(m), dbdx(m), dcdx(m), cosx)
        call get_ddxj(dijkl, bijk, cjkl, dddx(m), dbdx(m), dcdx(m), sinx)
        dcosdx(m) = cosx
        dsindx(m) = sinx
        
        endif

    enddo

end subroutine get_phi_gradient

subroutine get_phi_hessian(aijkl, bijk, cjkl, dijkl, dadx, dbdx, dcdx, dddx, &
                            d2adxdy, d2bdxdy, d2cdxdy, d2ddxdy, d2cosdxdy, d2sindxdy)
    real(8), intent(in) :: aijkl, bijk, cjkl, dijkl, dadx(12), dbdx(12), dcdx(12), dddx(12)
    real(8), intent(in) :: d2adxdy(78), d2bdxdy(78), d2cdxdy(78), d2ddxdy(78)
    real(8), intent(out) :: d2cosdxdy(78), d2sindxdy(78)
    real(8) :: cosxy, sinxy
    integer :: m, i, j
   
    do m=1, 78

        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2

        call get_d2dxdy(aijkl, bijk, cjkl, dadx(i), dadx(j), d2adxdy(m), dbdx(i), dbdx(j), d2bdxdy(m), &
                         dcdx(i), dcdx(j), d2cdxdy(m), cosxy)

        call get_d2dxdy(dijkl, bijk, cjkl, dddx(i), dddx(j), d2ddxdy(m), dbdx(i), dbdx(j), d2bdxdy(m), &
                         dcdx(i), dcdx(j), d2cdxdy(m), sinxy)

        d2cosdxdy(m) = cosxy

        d2sindxdy(m) = sinxy
        
    enddo

end subroutine get_phi_hessian

subroutine get_d2dxdy(aijkl, bijk, cjkl, dadx, dady, d2adxdy, dbdx, dbdy, d2bdxdy, dcdx, dcdy, d2cdxdy, d2dxdy)

    real(8), intent(in) :: aijkl, bijk, cjkl, dadx, dady, d2adxdy, dbdx, dbdy, d2bdxdy, dcdx, dcdy, d2cdxdy
    real(8), intent(out) :: d2dxdy
    real(8) :: term1, term2, term3, term4, term5, term6, term7, term8, term9, term10, term11

    term1 = aijkl*d2cdxdy/cjkl
    term2 = 2*aijkl*dcdx*dcdy/(cjkl**2)
    term3 = aijkl*d2bdxdy/bijk
    term4 = aijkl*dbdx*dcdy/(bijk*cjkl)
    term5 = aijkl*dbdy*dcdx/(bijk*cjkl)
    term6 = 2*aijkl*dbdx*dbdy/(bijk**2)
    term7 = d2adxdy
    term8 = dadx*dcdy/cjkl
    term9 = dady*dcdx/cjkl
    term10 = dadx*dbdy/bijk
    term11 = dady*dbdx/bijk
    d2dxdy = (-term1+term2-term3+term4+term5+term6+term7-term8-term9-term10-term11)/(bijk*cjkl)

end subroutine get_d2dxdy

subroutine get_dVdihedraldx(dcosdx, dsindx, k_dihedrals, cosphi0, sinphi0, cosphi, sinphi, dVdihedraldx)
real(8), intent(in) :: dcosdx, dsindx, k_dihedrals, cosphi0, sinphi0, cosphi, sinphi
real(8), intent(out) :: dVdihedraldx

dVdihedraldx = -2*k_dihedrals*((cosphi0-cosphi)*dcosdx+(sinphi0-sinphi)*dsindx)

end subroutine get_dVdihedraldx

subroutine get_d2Vdihedraldxdy(dcosdx, dcosdy, d2cosdxdy, dsindx, dsindy, d2sindxdy, k_dihedrals, cosphi0, sinphi0, &
                                cosphi, sinphi, d2Vdihedraldxdy)
real(8), intent(in) :: dcosdx, dcosdy, d2cosdxdy, dsindx, dsindy, d2sindxdy, k_dihedrals, cosphi0, sinphi0, cosphi, sinphi
real(8), intent(out) :: d2Vdihedraldxdy

d2Vdihedraldxdy = 2*k_dihedrals*dcosdx*dcosdy-2*k_dihedrals*(cosphi0 - cosphi)*d2cosdxdy &
                 + 2*k_dihedrals*dsindx*dsindy-2*k_dihedrals*(sinphi0 - sinphi)*d2sindxdy

end subroutine get_d2Vdihedraldxdy

subroutine get_ddxi(aijkl, bijk, cjkl, dadxi, dbdxi, ddxi)
    real(8), intent(in) :: aijkl, cjkl, bijk, dadxi, dbdxi
    real(8), intent(out) :: ddxi

    ddxi = - (aijkl*dbdxi)/(bijk**2*cjkl) + dadxi/(bijk*cjkl)

end subroutine get_ddxi

subroutine get_ddxj(aijkl, bijk, cjkl, dadxj, dbdxj, dcdxj, ddxj)
    real(8), intent(in) :: aijkl, cjkl, bijk, dadxj, dbdxj,dcdxj
    real(8), intent(out) :: ddxj

    ddxj = - (aijkl*dcdxj)/(bijk*cjkl**2)-(aijkl*dbdxj)/(bijk**2*cjkl)+dadxj/(bijk*cjkl)

end subroutine get_ddxj

end module dihedral_derivatives

module valence_conditions
implicit none
public :: get_total_charge, get_atomic_charge, check_bo_matrix,check_valence
integer, parameter :: wp = selected_real_kind(15)

integer, parameter :: valence_electrons(118) = (/ 1, 2, &
                    1, 2, 3, 4, 5, 6, 7, 8, &
                    1, 2, 3, 4, 5, 6, 7, 8, &
                    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, &
                    3, 4, 5, 6, 7, 8, &
                    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, &
                    3, 4, 5, 6, 7, 8, &
                    1, 2, &
                    3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, &
                    4, 5, 6, 7, 8, 9, 10, 11, 12, 3, 4, 5, 6, 7, 8, & 
                    1, 2, &
                    3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, &
                    4, 5, 6, 7, 8, 9, 10, 11, 12, 3, 4, 5, 6, 7, 8 /)
contains


subroutine get_total_charge(n_atoms, atoms, ideal_valence, are_core, bo_matrix, energy, sum_abs_charge, abs_sum_charge)
    integer, intent(in) :: n_atoms
    integer, intent(in) :: bo_matrix(:,:)
    integer, intent(in) :: ideal_valence(:)
    integer, intent(in) :: are_core(:)
    integer, intent(in) :: atoms(:)
    integer, intent(out) :: energy, sum_abs_charge, abs_sum_charge
    integer :: current_valences(n_atoms)
    integer :: current_valence,sum_charge
    integer :: i, j, k, l, q
    !write(*,*) "are_core", are_core
    current_valences = 0
    energy = 0 
    do k = 1, n_atoms
        if (are_core(k) == 0) cycle
        current_valence = 0
        do l = 1, n_atoms
            current_valence = current_valence + bo_matrix(k,l)
            energy = energy + bo_matrix(k,l)
        enddo
        current_valences(k) = current_valence
    enddo

    sum_abs_charge = 0
    sum_charge = 0

    do i=1, n_atoms
        if (are_core(i) == 0) cycle
        call get_atomic_charge(atoms(i), current_valences(i), q)
        !write(*,*) i, atoms(i), current_valences(i), q
        !q = ideal_valence(i) - current_valences(i)
        sum_abs_charge = sum_abs_charge + abs(q)
        sum_charge = sum_charge + q
    enddo
    
    abs_sum_charge = abs(sum_charge)

end subroutine get_total_charge

subroutine get_atomic_charge(atom, current_valence, charge)
    integer, intent(in) :: atom
    integer, intent(in) :: current_valence
    integer, intent(out) :: charge
    integer :: i

    if (atom == 1) then
        charge = 1 - current_valence
    else if (atom == 5) then
        charge = 3 - current_valence
    else if (atom == 7 .and. current_valence==3) then
        charge = 0
    else if (atom == 7 .and. current_valence==4) then
        charge = 1
    else if (atom == 7 .and. current_valence==2) then
        charge = -1
    else if (atom == 7 .and. current_valence==1) then
        charge = -2
    else if (atom == 8 .and. current_valence==2) then
        charge = 0
    else if (atom == 8 .and. current_valence==1) then
        charge = -1
    else if (atom == 15 .and. current_valence==5) then
        charge = 0
    else if (atom == 16 .and. current_valence==6) then
        charge = 0
    else if (current_valence /= 0) then
        charge = valence_electrons(atom) - current_valence
    else
        charge = 0
    endif

end subroutine get_atomic_charge

subroutine check_bo_matrix(n_atoms, cn_matrix, bo_matrix, valence, degree_unsaturation, healthy)
    integer, intent(in) :: n_atoms
    integer, intent(in) :: cn_matrix(:,:), bo_matrix(:,:)
    integer, intent(in) :: valence(:)
    integer, intent(in) :: degree_unsaturation(:)
    logical, intent(out) :: healthy
    logical :: checked_valence
    integer :: degree, i, j, sum_of_additional_bo

    call check_valence(n_atoms, bo_matrix, valence, checked_valence)

    if (checked_valence .eqv. .false.) then
        healthy = .false.
        return
    endif

    degree  = sum(degree_unsaturation)
    sum_of_additional_bo = 0
    do i=1, size(cn_matrix, dim=1)
        do j=1, size(cn_matrix, dim=2)
            sum_of_additional_bo = sum_of_additional_bo + bo_matrix(i,j) - cn_matrix(i,j)
        enddo
    enddo

    if (sum_of_additional_bo /= degree) then
        healthy = .false.
        return
    endif

    healthy = .true.

end subroutine check_bo_matrix

subroutine check_valence(n_atoms, bo_matrix, valence, healthy)
    integer, intent(in) :: n_atoms
    integer, intent(in) :: bo_matrix(:,:)
    integer, intent(in) :: valence(:)
    logical, intent(out) :: healthy
    integer :: i
    integer :: actual_valence_per_atom(n_atoms)

    do i=1, n_atoms
        actual_valence_per_atom(i) = sum(bo_matrix(:,i))
    enddo
    do i=1, n_atoms
        if (actual_valence_per_atom(i) > valence(i)) then
            healthy = .false.
            return
        endif
    enddo

    healthy = .true.

end subroutine check_valence

end module valence_conditions

module b_angle_derivatives
use fortran_helper, only: gidx
implicit none
public :: get_b_angle_derivatives
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_b_angle_derivatives(xij,yij,zij,bij,dbdx,d2bdxdy)
    real(8), intent(in) :: xij,yij,zij,bij
    real(8), intent(out) :: dbdx(9),d2bdxdy(45)

    call get_bgradient(xij,yij,zij,bij,dbdx)
    call get_bhessian(xij,yij,zij,bij,d2bdxdy)

end subroutine get_b_angle_derivatives


subroutine get_bhessian(xij,yij,zij,bij,d2bdxdy)
    real(8), intent(in) :: xij,yij,zij, bij
    real(8), intent(out) :: d2bdxdy(45)
    real(8) :: derivative
    integer :: ij

    d2bdxdy = 0.0_wp

    call get_d2bdxidxi(yij, zij, bij, derivative)
    call gidx(1, 1, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(zij, xij, bij, derivative)
    call gidx(2, 2, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(xij, yij, bij, derivative)
    call gidx(3, 3, ij)
    d2bdxdy(ij) = derivative

    call get_d2bdxidyi(xij, yij ,bij, derivative)
    call gidx(1, 2, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(xij, zij ,bij, derivative)
    call gidx(1, 3, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(yij, zij ,bij, derivative)
    call gidx(2, 3, ij)
    d2bdxdy(ij) = derivative

    call get_d2bdxidxi(yij, zij, bij, derivative)
    call gidx(4, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(zij, xij, bij, derivative)
    call gidx(5, 5, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxi(xij, yij, bij, derivative)
    call gidx(6, 6, ij)
    d2bdxdy(ij) = derivative

    call get_d2bdxidyi(xij, yij ,bij, derivative)
    call gidx(4, 5, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(xij, zij ,bij, derivative)
    call gidx(4, 6, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyi(yij, zij ,bij, derivative)
    call gidx(5, 6, ij)
    d2bdxdy(ij) = derivative

    call get_d2bdxidxj(yij, zij,bij, derivative)
    call gidx(1, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxj(zij, xij,bij, derivative)
    call gidx(2, 5, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidxj(xij, yij,bij, derivative)
    call gidx(3, 6, ij)
    d2bdxdy(ij) = derivative

    call get_d2bdxidyj(xij, yij ,bij, derivative)
    call gidx(1, 5, ij)
    d2bdxdy(ij) = derivative
    call gidx(2, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(xij, zij ,bij, derivative)
    call gidx(1, 6, ij)
    d2bdxdy(ij) = derivative
    call gidx(3, 4, ij)
    d2bdxdy(ij) = derivative
    call get_d2bdxidyj(yij, zij ,bij, derivative)
    call gidx(2, 6, ij)
    d2bdxdy(ij) = derivative
    call gidx(3, 5, ij)
    d2bdxdy(ij) = derivative

end subroutine get_bhessian


subroutine get_d2bdxidxi(yij, zij, bij, derivative)

real(8), intent(in) :: yij, zij, bij
real(8), intent(out) :: derivative
derivative = (yij**2+zij**2)/bij**3
end subroutine get_d2bdxidxi

subroutine get_d2bdxidyi(xij, yij ,bij, derivative)

real(8), intent(in) :: xij, yij, bij
real(8), intent(out) :: derivative
derivative = -(xij*yij)/bij**3
end subroutine get_d2bdxidyi

subroutine get_d2bdxidxj(yij, zij,bij, derivative)

real(8), intent(in) :: yij, zij, bij
real(8), intent(out) :: derivative
derivative = -(yij**2+zij**2)/bij**3
end subroutine get_d2bdxidxj

subroutine get_d2bdxidyj(xij, yij ,bij, derivative)

real(8), intent(in) :: xij, yij, bij
real(8), intent(out) :: derivative
derivative = (xij*yij)/bij**3
end subroutine get_d2bdxidyj


subroutine get_bgradient(xij,yij,zij,bij,dbdx)
    real(8), intent(in) :: xij,yij,zij, bij
    real(8), intent(out) :: dbdx(9)
    real(8) :: ddx, ddy, ddz

    dbdx = 0.0_wp

    call get_dbdxi(xij,bij,ddx)
    call get_dbdxi(yij,bij,ddy)
    call get_dbdxi(zij,bij,ddz)

    dbdx(1) = ddx
    dbdx(2) = ddy
    dbdx(3) = ddz 

    call get_dbdxi(xij,bij,ddx)
    call get_dbdxi(yij,bij,ddy)
    call get_dbdxi(zij,bij,ddz)

    dbdx(4) = -ddx
    dbdx(5) = -ddy
    dbdx(6) = -ddz 

end subroutine get_bgradient

subroutine get_dbdxi(xij,bij,derivative)
    real(8), intent(in) :: xij, bij
    real(8), intent(out) :: derivative
    derivative = xij/bij
end subroutine get_dbdxi

subroutine get_dbdxj(xij,bij,derivative)
    real(8), intent(in) :: xij, bij
    real(8), intent(out) :: derivative
    derivative = -xij/bij
end subroutine get_dbdxj
end module b_angle_derivatives

module opd
implicit none
public :: get_index
integer, parameter :: wp = selected_real_kind(15)

contains

subroutine get_index(n_atoms, geometry, priorities, G_os)

    real(8), intent(in) :: geometry(:, :), priorities(:)
    integer, intent(in) ::  n_atoms
    real(8), intent(out) :: G_os
    integer :: i,j,k,l,n,m
    real(8) :: G_ijkl, G, n_atoms_float

    n_atoms_float = n_atoms

    n = 2

    m = 1

    G = 0.0_wp

    do i = 1, n_atoms
        do j = 1, n_atoms
            do k = 1, n_atoms
                do l = 1, n_atoms
                    if (i /= j .and. j /= k .and. k /= l .and. i /= l) then
                        call get_G_ijkl(i,j,k,l, geometry, priorities, G_ijkl)
                        G = G + G_ijkl
                    end if
                end do
            end do
        end do
    end do

    G_os = 24.0_wp/(n_atoms_float**4)*(1.0_wp/3.0_wp)*G

end subroutine

subroutine get_G_ijkl(i,j,k,l, geometry, priorities, G_ijkl)

    real(8), intent(in) :: geometry(:, :), priorities(:)
    integer, intent(in) ::  i, j, k, l
    real(8), intent(out) :: G_ijkl
    real(8) :: r_ij(3), r_kl(3), r_il(3), r_jk(3),c_ijkl(3)
    real(8) :: r_ij_mag, r_kl_mag, r_il_mag, r_jk_mag, mw, d_ijjk, d_jkkl, d_ijklil
    real(8) :: G_ijkl_up, G_ijkl_down

    call get_vector(geometry, i, j, r_ij, r_ij_mag)

    call get_vector(geometry, k, l, r_kl, r_kl_mag)

    call get_vector(geometry, i, l, r_il, r_il_mag)

    call get_vector(geometry, j, k, r_jk, r_jk_mag)

    mw = priorities(i)*priorities(j)*priorities(k)*priorities(l)

    call get_cross(r_ij, r_kl, c_ijkl)

    call get_dot(r_ij, r_jk, d_ijjk)

    call get_dot(r_jk, r_kl, d_jkkl)

    call get_dot(c_ijkl, r_il, d_ijklil)

    G_ijkl_up = d_ijklil*d_ijjk*d_jkkl

    G_ijkl_down = ((r_ij_mag*r_jk_mag*r_kl_mag)**2)*((r_il_mag)**1)

    G_ijkl = mw*G_ijkl_up/G_ijkl_down


end subroutine


subroutine get_vector(geometry, i, j, vec, mag)

    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) ::  i,j
    real(8), intent(out) :: vec(3), mag

    integer :: n

    do n=1, 3

        vec(n) = geometry(n,i)-geometry(n,j)

    enddo

    mag = 0.0_wp

    do n=1, 3

        mag = mag + vec(n)**2

    enddo

    mag = sqrt(mag)

end subroutine

subroutine get_cross(a, b, c)

    real(8), intent(in) :: a(3), b(3)
    real(8), intent(out) :: c(3)

    c(1) = a(2) * b(3) - a(3) * b(2)
    c(2) = a(3) * b(1) - a(1) * b(3)
    c(3) = a(1) * b(2) - a(2) * b(1)
end subroutine

subroutine get_dot(a, b, c)

    real(8), intent(in) :: a(3), b(3)
    real(8), intent(out) :: c

    c = a(1) * b(1) + a(2) * b(2) + a(3) * b(3)

end subroutine

end module

module repulsion_derivatives

use fortran_helper, only : get_bij
use inv_rij_derivatives, only: get_inverse_distance_derivatives
implicit none
public :: get_repulsion_derivatives, get_repulsion_gradient, get_repulsion_hessian
integer, parameter :: wp = selected_real_kind(15)
contains

subroutine get_repulsion_derivatives(geometry, repulsive_partner, charges, gradient, hessian)
    real(8), intent(in) :: geometry(:, :), charges(:)
    integer, intent(in) ::  repulsive_partner(:, :)
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    integer :: n

    do n=1, size(charges)
        call get_single_repulsion_derivative(geometry, repulsive_partner(:,n), charges(n), gradient, hessian)
    enddo

end subroutine get_repulsion_derivatives

subroutine get_repulsion_gradient(geometry, repulsive_partner, charges, gradient)
    real(8), intent(in) :: geometry(:, :), charges(:)
    integer, intent(in) ::  repulsive_partner(:, :)
    real(8), intent(inout) :: gradient(:)
    integer :: n

    do n=1, size(charges)
        call get_single_repulsion_gradient(geometry, repulsive_partner(:,n), charges(n), gradient)
    enddo

end subroutine get_repulsion_gradient

subroutine get_repulsion_hessian(geometry, repulsive_partner, charges, hessian)
    real(8), intent(in) :: geometry(:, :), charges(:)
    integer, intent(in) ::  repulsive_partner(:, :)
    real(8), intent(inout) :: hessian(:,:)
    integer :: n

    do n=1, size(charges)
        call get_single_repulsion_hessian(geometry, repulsive_partner(:,n), charges(n), hessian(:,:))
    enddo

end subroutine get_repulsion_hessian

subroutine get_single_repulsion_gradient(geometry, partner, charge, gradient)
    real(8), intent(in) :: geometry(:, :), charge
    integer, intent(in) ::  partner(2)
    real(8), intent(inout) :: gradient(:)
    real(8) :: rij
    integer :: i,j
    integer :: xhat(6)
    real(8) :: dqdx(6), d2qdxdy(21)

    i = partner(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = partner(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    call get_inv_dist_derivatives(geometry, i, j, dqdx, d2qdxdy, rij)

    call build_repulsion_gradient(rij, dqdx, charge, xhat, gradient)

end subroutine get_single_repulsion_gradient

subroutine get_single_repulsion_hessian(geometry, partner, charge, hessian)
    real(8), intent(in) :: geometry(:, :), charge
    integer, intent(in) ::  partner(2)
    real(8), intent(inout) :: hessian(:,:)
    real(8) :: rij
    integer :: i,j
    integer :: xhat(6)
    real(8) :: dqdx(6), d2qdxdy(21)

    i = partner(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = partner(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    call get_inv_dist_derivatives(geometry, i, j, dqdx, d2qdxdy, rij)

    call build_repulsion_hessian(rij, d2qdxdy, charge, xhat, hessian)

end subroutine get_single_repulsion_hessian

subroutine get_single_repulsion_derivative(geometry, partner, charge, gradient, hessian)
    real(8), intent(in) :: geometry(:, :), charge
    integer, intent(in) ::  partner(2)
    real(8), intent(inout) :: gradient(:), hessian(:,:)
    real(8) :: rij
    integer :: i,j
    integer :: xhat(6)
    real(8) :: dqdx(6), d2qdxdy(21)

    i = partner(1)

    xhat(1) = 1+3*(i-1)
    xhat(2) = 2+3*(i-1)
    xhat(3) = 3+3*(i-1)

    j = partner(2)

    xhat(4) = 1+3*(j-1)
    xhat(5) = 2+3*(j-1)
    xhat(6) = 3+3*(j-1)

    call get_inv_dist_derivatives(geometry, i, j, dqdx, d2qdxdy, rij)

    call build_repulsion_gradient(rij, dqdx, charge, xhat, gradient)

    call build_repulsion_hessian(rij, d2qdxdy, charge, xhat, hessian)

end subroutine get_single_repulsion_derivative

subroutine build_repulsion_gradient(rij, dqdx, charge, xhat, gradient)

    real(8), intent(in) :: rij, dqdx(6), charge
    integer, intent(in) :: xhat(6)
    real(8), intent(inout) :: gradient(:)
    real(8) :: g
    integer :: n

    do n=1, 6
        gradient(xhat(n)) = gradient(xhat(n)) + charge*dqdx(n)
    enddo

end subroutine build_repulsion_gradient

subroutine build_repulsion_hessian(rij, d2qdxdy, charge, xhat, hessian)

    real(8), intent(in) :: rij,d2qdxdy(21)
    real(8), intent(in) :: charge
    integer, intent(in) :: xhat(6)
    real(8), intent(inout) :: hessian(:,:)
    real(8) :: h
    integer :: m, i, j

    do m=1, 21

        j = floor((sqrt(8*real(m) - 7) + 1) / 2)
        i = m - (j-1)*j/2

        hessian(xhat(i), xhat(j)) = hessian(xhat(i), xhat(j)) + charge*d2qdxdy(m)

        if (i /= j) then

            hessian(xhat(j), xhat(i)) = hessian(xhat(j), xhat(i)) + charge*d2qdxdy(m)
        endif
    enddo

end subroutine build_repulsion_hessian

subroutine get_inv_dist_derivatives(geometry, i, j, dqdx, d2qdxdy, rij)
    real(8), intent(in) :: geometry(:, :)
    integer, intent(in) :: i, j
    real(8), intent(out) :: dqdx(6), d2qdxdy(21)
    real(8), intent(out) :: rij
    real(8) :: xij, yij, zij, dbdx(9)
    integer :: m

    xij = geometry(1,i) - geometry(1,j)
    yij = geometry(2,i) - geometry(2,j)
    zij = geometry(3,i) - geometry(3,j)

    call get_bij(geometry, i, j, rij)

    call get_inverse_distance_derivatives(xij,yij,zij,rij,dqdx,d2qdxdy)

end subroutine get_inv_dist_derivatives


end module repulsion_derivatives
